/* file easynum.c

Wed Nov 17 14:24:46 MET 1999
Fri May 14 18:41:48 METDST 1999
Thu Aug 27 13:51:27 METDST 1998
Mon Feb 16 14:55:41 MET    1998
Fri Oct 10 16:45:23 METDST 1997
Fri Mar 28 14:27:21 MET    1997

title:     EASYNUM                 
author:    Pavel Pokorny           
           Prague Institute of Chemical Technology 
e-mail:    Pavel.Pokorny@vscht.cz  
publisher: Pavel Pokorny Praha  
ISBN:      80-901886-1-3             

available: 
<http://staff.vscht.cz/mat/Pavel.Pokorny/easynum/>
tiger.vscht.cz(147.33.5.11):/pub/xpplot/easynum.tar.gz
-------------------------------------------------------------
Copyright (c) 1995-99 Pavel Pokorny   

This software (EASYNUM) comes with GNU General Public License, see
http://www.gnu.ai.mit.edu/copyleft/gpl.html
-------------------------------------------------------------
The C code is written so that
gcc (version 2.8.0)  -Wall -O2 -ggdb 
is happy.
-------------------------------------------------------------
time to compile easynum.c and to run SolveLin for dim=200 on hp712

cc (HP-UX 10.20) 8.2 s  2.28 s
cc +O1          14      1.39
cc +O2          42      0.66
cc +O3         147      0.65
cc +O4         157      0.65

gcc (2.7.2.3)   23.6    4.36
gcc -O1         29      0.8
gcc -O2         38      0.8
gcc -O3         54      0.8
gcc -O4         55      0.8
-------------------------------------------------------------
List of functions:

seteps0 (x)
seth0   (x)
real myrand ()
called (s,n)
leave (s)

timeaction (argc,argv,action)
real usedtime ()

wrla()
wri (s,i)
wrf (s,x)
wrl ()
wrli (s,i)
wrlf (s,x)

vali (s)
long vall (s)
real valf (s)

timesmm (A,B,C,d1,d2,d3)     A = B.C  
timesmv (y,A,x,d1,d2)        y = A.x  
timessv (y,s,x,d)            y = s x  
timessm (A,s,B,d1,d2)        A = s B  
plusmm  (A,B,C,d1,d2)        A = B + C   
minusmm (A,B,C,d1,d2)        A = B - C
plusvv  (x,y,z,d)            x = y + z  
minusvv (x,y,z,d)            x = y - z
copy  (x,y,d)                x = y
void copymatrix (A,B,d1,d2)
int fileexists (s)
void  ppopenr (af,s)
void  ppopenww (af,s)
void  ppopenw (af,s)
void  ppopena (af,s)

fwritematrix (f,header,A,d1,d2)
swritematrix (fn,header,A,d1,d2)
writematrix (s,a,d1,d2)
fwritevector (f,header,v,d)
swritevector (fn,header,v,d)
writevector (s,a,d)
wvector (x,d)

void invmat1 (a,d)
void invmat2 (a,d)
void invmatn (A,d)
void invmat (a,d)
solvelin (A,x,y,d)
SolveLin (Ao,xo,bo,d)
make1matrix (E,d)
make0matrix (A,d)
makerandmatrix (E,d)
makesymrandmatrix (E,d)
makezerovector (x,d)
sqrvector (x,d)
sqrtvector (x,d)
sumnormvector (x,d)

real norm (x,d)
real anorm (x,d)
real matrixnorm (A,d1,d2)
void difference  (x,y,d)
real distance (x,y,d)
real adistance (x,y,d)
normalize (x,d)
void anormalize (x,d)
real scalprod (x,y,d)
real findangle  (x,y,d)
transpose (a,b,d)
void allocdata (x,n)
void alloclong (x,n)
void er (s)
void erp ()
void freaddata (x,n,f)
void readdata (x,n,s)
int Round (wx)
long Roundl (wx)

readmatrix (A,d,s)
extractdiag (x,A,d)

rk (x0,yo,h0,e0,y,ah,ae,f,p,d)
kub  (t0,x0,h,f,g,J, at,x,d)
kub3e (t0,x0,h0,eps0, x,ah,aeps,F,p,d)
void grk (xo,yo,y,h,f,p,d)
void rkr (x,yo,y,e,h,f,p,d)
void prk (t0,x0,h0,eps0, x,ah,aeps,f,p,d)

checkstep (ax0,yo,ah0,acor,f,p,d)
integ1h  (at, y,f,p,d)
integnh  (at, y,f,p,d,n)
integdt  (t,T,y,f,p,d)
integdtb (t,T,y,f,p,d)
integdte (t,T,y,pne,f,p,d)

subdet (S,A,d,m,n)
real det (A,d)
outer (z,A,d)
jacob (J,pf,x0,d)

newton (x,pf,d)
grad (g,pf,x0,d)
difference  (x,y,d)
real distance (x,y,d)
real adistance (x,y,d)
in (x,x1,x2,d)
tangent (t,x,f,d)
solve2alg (x,a)
eigv2 (eig,j)
double mycbrt (x)
double myacosh (x)
double myasinh (x)

solve3alg (x,C)
void make_char_eqn3 (C,J)
void eigenvalues3 (e,J)

setstac (y,T,f,p,d)
perturbation (y,A)
oneyear (y,T,A,pne,f,p,d)
real rotrat (T,A,f,p,d)

long wc (f)

prepranddata (x,n)
prepndata (x,n)
printdata (x,n)
sprintdata (x,n,s)
sprintldata (x,n,s)
print2data (x,y,n)
revdata (x,n)
revmatrix (A,d)
logdata (x,n)
void centerdata (x,n)
windowdata (x,n)

subsortdata (x,l,r)
sortdata (x,n)
subsortdatai (x,index,l,r)
sortdatai (x,index,n)
subsortdata3 (x,l,r,y,z)
sortdata3 (x,n,y,z)
subsortdatavm (x,A,d,l,r)
sortdatavm (x,A,d)

minmax (x,dl,pxmin,pxmax)
void sfiltrdata (x,n)
void s2filtrdata (x,y,n)
filtrdata (x,y,n,m)
standardize (x,n)
void astandardize (x,a,n)
autocor (x,y,n)
void accumdata (x,n)
void accumpdata (x,n,p)
real Log2 (wx) real wx; {return (Log(wx)/Log(2));}

sqrtc (y,x)
sqrc  (y,x)

rk6 (t,x,h,f)
vectprod (x,a,b,d)
perpen (a,b,x,d)
real lnf (x)
real lnfs (x)

# ifdef HIGH_PRECISION

long double ldfrac (x)

long double ldsin (x)
long double ldcos (x)
long double ldrsin (x)
long double ldrcos (x)

long double ldsqrt (x)

long double ldSin (x)
long double ldCos (x)
long double ldmsin (v)
long double ldmcos (v)

ldwrite(x)
long double ldabs (x)
long double ldlog (x)

# endif

rktest (to,yo,h,ea,eb,ec,f,p,d)
rktesttab (to,yo,f,p,d)

orthonormalizen (e0,D,e,n,d)
real cosfi (a,b,d)

v2M (M,v,n,d)
M2v (v,M,n,d)
LE (x,le,F,p,T,TT,o,steps,nle,d)
LEd (x,le,F,p,iT,iTT,o,steps,nle,d)

binprintshort (b)
binprintdouble (x)

ilog2 (x)
ildlog2 (x)

long two2n (n)
long bitinv (n,size,columns)
reorder(x,size,columns)
TrigTable (csn,size)
fht (x,size)
MakeSpectrum (spectrum,x,size)

lookline (T,mgn,pos,i,d)
checkline (T,mgn,pos,i,p,q)
firstlook (T,mgn,pos,d)
look (T,mgn,pos,p,q,nar,d)
diagiter (T, R, mgn, pos, nar, pp, pq, d)
diagonalize (A,Q,D,d)

lsm (x,y,n,c,d,e,r,L)
real corcoef (x,y,n)
real Nad (a,b)
real Bezier1 (t,a,N)

void cco1 (x1,p,yl,v1,J,d)
void cco2 (J,dx,d)
void cco3 (eps1,eps2,v1,v2,p,x1,x2,dx,y2,n,N,m,M,s,d)
void cco4 (x0,dx,p,d)
int curvecorrector (x0,t,f,p,J,d)
void curve (x,x1,x2,t,noutmax,h,hmin,hmax,f,fout,p,d)
void verbq_conti (t,eig)
void verbq_discr (t,eig)

real defint (f,a,b,n,m)
definttest ()

findcycle (x,n,i1,i2,f,p,dim)

readparams (p,s,d)

void dyn_type_disc_3 (ae,e,J)

printPSprolog ()
printPSepilog ()
makePSgrid (N)

End of the list of functions.

*/
/*******************************************/
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <stdlib.h>
/* #include <sys/times.h> */
#include <string.h>
/* #include <unistd.h> */
#include <signal.h>
#include <limits.h>

# ifndef OUT_FORMAT
# define OUT_FORMAT "%.5G "
# endif /* OUT_FORMAT */

# ifndef DIM
# define DIM 20
# endif /* DIM */

# ifndef DIM2
# define DIM2 100
# endif /* DIM2 */

# ifdef HIGH_PRECISION
/*-----------------------------------------------------*/
# define EPS 1E-34L
# define ldeps  1E-35L

# define PiHalf 1.5707963267948966192313216916397514420986L
# define Pi     3.1415926535897932384626433832795028841972L
# define Pi3_2  4.712388980384689857693965074919254326296L
# define twoPi  6.283185307179586476925286766559005768394L
# define Pito2  9.869604401089358618834490999876151135314L
# define Pito3 31.00627668029982017547631506710139520223L
# define Pito4 97.4090910340024372364403326887051112497L
 /* 40 digits */

# define real long double
# define Sin(x)    (ldsin((real)(x)))
# define Cos(x)    (ldcos((real)(x)))
# define Sqrt(x)   (ldsqrt((real)(x)))

# define Abs(x)    (ldabs((real)(x)))
# define Log(x)    (ldlog((real)(x)))

long double ldfrac (long double);
long double ldsin  (long double);
long double ldcos  (long double);
long double ldSin  (long double);
long double ldCos  (long double);

long double ldsqrt (long double);
long double ldabs  (long double);
long double ldlog  (long double);

/*-----------------------------------------------------*/
# else /*  not  HIGH_PRECISION */
/*-----------------------------------------------------*/
# define EPS 1E-16

# define PiHalf 1.5707963267948966192313216916397514420986
# define Pi     3.1415926535897932384626433832795028841972
# define Pi3_2  4.712388980384689857693965074919254326296
# define twoPi  6.283185307179586476925286766559005768394
# define Pito2  9.869604401089358618834490999876151135314
# define Pito3 31.00627668029982017547631506710139520223
# define Pito4 97.4090910340024372364403326887051112497
 /* 40 digits */

# define real  double
# define Sin(x)    (sin((real)(x)))
# define Cos(x)    (cos((real)(x)))
# define Sqrt(x)   (sqrt((real)(x)))

# define Abs(x)    (fabs((real)(x)))
# define Log(x)    (log((real)(x)))

/*-----------------------------------------------------*/
# endif  /*  HIGH_PRECISION */

typedef real   vector  [DIM];
typedef vector matrix  [DIM];
typedef vector vectors [DIM2];
typedef int    ivector [DIM];

extern void exit();
int gprinth= 0; /* flag to print step size  */
int debug  = 0, /* flag to print debug info */
    debugl = 0; /* function calling level   */

# define FAST    0  /* local error = h^5 */
# define STIFF   1  /*               h^4 */
# define PRECISE 2  /*               h^8 */

int intmethod = FAST;

real
 geps0   = 1E-7,
 gh0     = 1E-6;
int globcormax = 0;
int globargc;
char **globargv;
real globhmin=1997;
real globhmax=0;
/************************************************/
# define seteps0(x) geps0 = x;
# define seth0(x)   gh0   = x;
/************************************************/
real myrand() { return ( rand() / (real)32768 ); }
real myrand3() { return ( 
 ((int)(1000 * (rand()/32768.0 - 0.5) )) / 1000.0
); }
/*
extern double drand48();
# define myrand drand48
*/
/************************************************/
void called (s,n)
 char *s;
 long *n;
{
 int i;

 ++ *n;
 for (i=0;i<debugl;i++)
  (void)fprintf(stderr," ");
 (void)fprintf(stderr,"%s called %ld\n",s,*n);
 debugl++;
} /* called */
/************************************************/
void leave (s)
 char *s;
{
 int i;

 debugl--;
 for (i=0;i<debugl;i++)
  (void)fprintf(stderr," ");
 (void)fprintf(stderr,"%s O.K.\n\n",s);
} /* leave */
/************************************************/
/*
# ifndef HIGH_PRECISION

timeaction (argc,argv,action)
 int argc;
 char **argv;
 int (*action)();
{
 time_t t1,t2;
 char s1[50],s2[50];
 int i;
 extern real usedtime();

 t1 = time ((time_t *)NULL);
 (void) strcpy (s1,ctime(&t1));
 for (i=0;i<50;i++) if (s1[i]==10) s1[i]=0;
 action (argc,argv);
 t2 = time ((time_t *)NULL);
 (void) strcpy (s2,ctime(&t2));
 for (i=0;i<50;i++) if (s2[i]==10) s2[i]=0;

 (void)fprintf (stderr,
   "program = %8s,  start = %s, end = %s, used = %G s \n",
   argv[0], s1, s2, usedtime());
}

real usedtime ()
{
 struct tms b;

 (void) times (&b);
 return (
  (b.tms_utime +
   b.tms_stime +
   b.tms_cutime +
   b.tms_cstime) / (real) CLK_TCK
 );
}
# endif
*/
/************************************************/
void wrla()    /* writeln asterisk */
{
  (void) printf (" * \n");
} /* wrla */
/************************************************/
void wri (s,i)  /* write int */
 char *s;
 int i;
{
 (void) printf ("%s%3d",s,i);
} /* wri */
/************************************************/
void wrf (s,x)  /* write float or real */
 char *s;
 real x;
{
 (void) printf ("%s%8.5G",s,x);
} /* wrf */
/************************************************/
void wrl ()   /* writeln */
{
 (void) printf ("\n");
} /* wrl */
/************************************************/
void wrli (s,i)  /* writeln int */
 char *s;
 int i;
{
 wri (s,i);
 wrl ();
} /* wrli */
/************************************************/
void wrlf (s,x)  /* writeln float or real */
 char *s;
 real x;
{
 wrf (s,x);
 wrl ();
} /* wrlf */
/************************************************/
int vali (s)
char *s;
{
 int i,is;

 is = sscanf(s,"%d",&i);
 if(is!=1){
  (void) fprintf (stderr,"error reading string %s\n",s);
  exit(1);
 };
 return (i);
} /* vali */
/************************************************/
long vall (s)
 char *s;
 {
  int is;
  long i;

  is = sscanf(s,"%ld",&i);
  if(is!=1){
   (void) fprintf (stderr,"error reading string %s\n",s);
   exit(1);
  };
  return (i);
 } /* vali */
/************************************************/
 real valf (s)
 char *s;
 {
  int is;
  double x;

  is = sscanf(s,"%lf",&x);
  if(is!=1){
   (void) fprintf (stderr,"error reading string \"%s\", number expected\n",s);
   exit(1);
  };
  return ((real)x);
 } /* valf */
/************************************************/
/************************************************/
void  timesmm (A,B,C,d1,d2,d3)   /*  A = B.C  */
  real A [DIM][DIM],B[DIM][DIM],C[DIM][DIM];
  int d1,d2,d3;
  {
   int i,j,n;
   real w,wA[DIM][DIM];

   for(i=0;i<d1;i++)
    for(j=0;j<d3;j++) {
     w = 0;
     for (n=0;n<d2;n++) w += B[i][n] * C[n][j];
     wA [i][j] = w;
    };
   for(i=0;i<d1;i++)
    for(j=0;j<d3;j++) A[i][j]=wA[i][j];
  } /* timesmm  */
/***************************************************/
void  timesmv (y,A,x,d1,d2)   /*  y = A.x  */
 real A[DIM][DIM], x[DIM], y[DIM];
 int d1,d2;
 {
  int i,j;
  real w,wv[DIM];

  for(i=0;i<d1;i++){
   w = 0;
   for(j=0;j<d2;j++) w += A[i][j]*x[j];
   wv[i] = w;
  };
  for (i=0;i<d1;i++) y[i] = wv[i];
 } /* timesmv */
/***************************************************/
void timessv (y,s,x,d)   /*  y = s x  */
  real s,x[DIM],y[DIM];
  int d;
  {
   int i;

   for (i=0;i<d;i++) y[i] = s * x[i];
  }  /* timessv  */
/***************************************************/
void timessm (A,s,B,d1,d2)     /*  A = s B  */
  real s,A[DIM][DIM],B[DIM][DIM];
  int d1,d2;

  {
   int i,j;

   for (i=0;i<d1;i++)
    for (j=0;j<d2;j++) A[i][j] = s * B[i][j];
  }  /*  timessm  */
/***************************************************/
void plusmm (A,B,C,d1,d2)    /*  A = B + C   */
  real A[DIM][DIM],B[DIM][DIM],C[DIM][DIM];
  int d1,d2;
  {
   int i,j;

   for (i=0;i<d1;i++)
    for (j=0;j<d2;j++) A[i][j] = B[i][j]+C[i][j];
  }  /*  plusmm  */
/***************************************************/
void minusmm (A,B,C,d1,d2)    /*  A = B - C   */
  real A[DIM][DIM],B[DIM][DIM],C[DIM][DIM];
  int d1,d2;
  {
   int i,j;

   for (i=0;i<d1;i++)
    for (j=0;j<d2;j++) A[i][j] = B[i][j]-C[i][j];
  }  /*  minusmm  */
/***************************************************/
void plusvv (x,y,z,d)      /*   x = y + z  */
  real *x,*y,*z;
  int d;
  {
   int i;

   for (i=0;i<d;i++) x[i] = y[i] + z[i];
  }  /*  plusvv  */
/***************************************************/
void minusvv (x,y,z,d)      /*   x = y - z  */
  real *x,*y,*z;
  int d;
  {
   int i;

   for (i=0;i<d;i++) x[i] = y[i] - z[i];
  }  /*  minusvv  */
/***************************************************/
void copy  (x,y,d)
 real *x,*y;
 int d;
 {
  int i;

  for (i=0;i<d;i++) x[i] = y[i];
 } /* copy */
/***************************************************/
void copymatrix (A,B,d1,d2)
 matrix A,B;
 int d1,d2;
{
 int i,j;

 for (i=0;i<d1;i++)
 for (j=0;j<d2;j++)
  A[i][j] = B[i][j];
} /* copymatrix */
/***************************************************/
/***************************************************/
int fileexists (s)
  char *s;
 {
  FILE *f;
  int r;

  f = fopen (s,"r");
  if (f != NULL) (void)fclose (f);
  if (f == NULL) r = 0;
  else           r = 1;

  return (r);
 } /* fileexists */
/************************************************/
void  ppopenr (af,s)
  FILE **af;
  char *s;
 {
  *af = fopen (s,"r");

  if (*af == NULL) {
   (void) fprintf (stderr,
    "error opening file %s for reading \n\n", s);
   exit (1);
  }
 }  /* ppopenr */
/************************************************/
void  ppopenww (af,s)
  FILE **af;
  char *s;
 {
  *af = fopen (s,"w");
  if (*af == NULL) {
   (void) fprintf (stderr,
    "error opening file %s for writing \n\n", s);
   exit (1);
  }
 } /* ppopenww */
 /************************************************/
void  ppopenw (af,s)
  FILE **af;
  char *s;
 {
  int c;

  if (fileexists (s)) {
   (void) fprintf (stderr,
    "warning : file %s exists, overwrite ? (y/n) ",s);
   c = getchar();
   if ((c != 'y')&&(c!='Y')) exit (1);
   while (getchar() != 10);
  }
  ppopenww (af,s);
 } /* ppopenw */
 /************************************************/
void  ppopena (af,s)
  FILE **af;
  char *s;
 {
  *af = fopen (s,"a");
  if (*af == NULL) {
   (void) fprintf (stderr,
    "error opening file %s for append \n\n", s);
   exit (1);
  }
 } /* ppopena */
/***************************************************/
void fwritematrix (f,header,A,d1,d2)
 FILE *f;
 char *header;
 matrix A;
 int d1,d2;
{
 int i,j;

 (void) fprintf (f,"%s\n",header);

 for(i=0;i<d1;i++){
  for(j=0;j<d2;j++) {
   (void) fprintf (f,OUT_FORMAT,(double) A[i][j]);
   if (d2 > 14) (void) fprintf (f,"\n");
  };
  (void) fprintf (f,"\n");
 };
} /* fwritematrix */
/***************************************************/
void swritematrix (fn,header,A,d1,d2)
 char *fn,*header;
 matrix A;
 int d1,d2;
{
 FILE *f;

 ppopenww (&f,fn);
 fwritematrix (f,header,A,d1,d2);
 (void) fclose (f);
} /* swritematrix */
/***************************************************/
void writematrix (header,A,d1,d2)
 char *header;
 matrix A;
 int d1,d2;
{
 fwritematrix (stdout,header,A,d1,d2);
} /* writematrix */
/************************************************/
void fwritevector (f,header,v,d)
 FILE *f;
 char *header;
 vector v;
 int d;
{
 int i;

 (void) fprintf (f,"%s",header);

 for(i=0;i<d;i++) {
  (void) fprintf (f,OUT_FORMAT,(double) v[i]);
  if (d > 10) (void) fprintf (f,"\n");
 };

 (void) fprintf (f,"\n");
 } /* fwritevector */
/************************************************/
void swritevector (fn,header,v,d)
 char *fn,*header;
 vector v;
 int d;
{
 FILE *f;

 ppopenww (&f,fn);
 fwritevector (f,header,v,d);
 (void) fclose (f);
} /* swritevector */
/************************************************/
void writevector (header,v,d)
 char *header;
 vector v;
 int d;
{
 fwritevector (stdout,header,v,d);
} /* writevector */
/************************************************/
void wvector (x,d)
 vector x;
 int d;
{
 int i;

 (void) printf ("\n");
 for (i=0;i<d;i++) (void) printf ("%G\n",x[i]);
} /* wvector */
/************************************************/
/************************************************/
void invmat1 (a,d)
  real a[DIM][DIM];
  int d;
 {
/*  extern void exit(); */

  if ((*a)==0){
   (void) printf("error inverting singular 1D matrix\n");
   writematrix("matrix = ",a,d,d);
   exit(1);
  };
  a[0][0] = 1 / a[0][0];
 } /* invmat1 */
/**************************************************/
void invmat2 (a,d)
  real a[DIM][DIM];
  int d;
 {
  real Det, w;

  Det = a[0][0]*a[1][1]-a[0][1]*a[1][0];

  if (Det==0){
   (void) fprintf(stderr,"error inverting singular 2D matrix\n");
   fwritematrix(stderr,"matrix = ",a,d,d);
   exit(1);
  };
  w       =  a[0][0];
  a[0][0] =  a[1][1]/Det;
  a[1][1] =  w      /Det;
  a[0][1] = -a[0][1]/Det;
  a[1][0] = -a[1][0]/Det;
 } /* invmat2 */
/**************************************************/
void invmatn (A,d)
  real A[DIM][DIM];
  int    d;
 {
  int    i,j,k,n;
  real w,wv[DIM],B[DIM][DIM];

  if(d>DIM){
   (void) fprintf(stderr,"sorry DIM = %d \n",DIM);
   exit (1);
  };

   for (i=0;i<d;i++)
    for (j=0;j<d;j++)
     B[i][j] = 0;
   for (i=0;i<d;i++)
    B [i][i] = 1;
   for (k=0;k<d;k++) {
     i = k;
     while ((A[i][k]==0) && (i<d)) i++;
     if (A[i][k] == 0) {
       (void) fprintf(stderr,"Error : inverting singular nD matrix\n");
       fwritematrix(stderr,"matrix = ",A,d,d);
       exit(1);
      };
     if (i>k) {
       for(n=0;n<d;n++) {
        wv[n]   = A[i][n];
        A[i][n] = A[k][n];
        A[k][n] =   wv[n];
        wv[n]   = B[i][n];
        B[i][n] = B[k][n];
        B[k][n] =   wv[n];
       };
      };
     w = A[k][k];
     for (i=k;i<d;i++) A[k][i] = A[k][i] / w;
     for (i=0;i<d;i++) B[k][i] = B[k][i] / w;
     for (j=k+1;j<d;j++) {
       w = A[j][k];
       for(i=k;i<d;i++)A[j][i] = A[j][i] - A[k][i] * w;
       for(i=0;i<d;i++)B[j][i] = B[j][i] - B[k][i] * w;
      };
    };
   for (k=d-2;k>=0;k--)
    for (j=k+1;j<d;j++)
     for (i=0;i<d;i++)
      B[k][i] = B[k][i] - A[k][j] * B[j][i];
  for(i=0;i<d;i++)
   for(j=0;j<d;j++)
    A[i][j] = B[i][j];
 } /* invmatn */
/**************************************************/
void invmat (a,d)
 real a[DIM][DIM];
 int d;
{
 if (d == 1) invmat1(a,d);
  else if (d==2) invmat2(a,d);
   else invmatn (a,d);
} /* invmat */
/**************************************************/
void solvelin (A,x,y,d)  /* A.x = y      */
 vector x,y;        /*  x  = Ainv.y */ 
 matrix A;
 int d;
{
 matrix Ainv;

 copymatrix (Ainv,A,d,d);
 invmat (Ainv,d);
 timesmv (x,Ainv,y,d,d);
} /* solvelin */
/************************************************/
void SolveLin (Ao,x,bo,d) /* solves A.x=b */
 matrix Ao;
 vector x,bo;
 int d;
{
 matrix A;
 real a,b,w,s;
 int i,j,r,I;

/*
For a 190x190 matrix
this function is 4.5 x faster and more precise
than the method using inverse matrix.

To compare with the famous program Mathematica 3.0, 
this function is 2 times faster and of the same precission.
(On hp9000/735 it takes 0.4 s to solve a system of 200 linear equations
and the max error |A.x-b| is 1E-12, our function takes 0.2 s.)
*/
/*------------------------------------------------*/
 if (DIM <= d) {
  (void) fprintf (stderr,"error in SolveLin, DIM must be more than dim\n");
  (void) fprintf (stderr,"dim = %d \n",d);
  (void) fprintf (stderr,"DIM = %d \n",DIM);
  exit (1);
 };
/*------------------------------------------------*/
 for (i=0;i<d;i++)
 for (j=0;j<d;j++)
  A[i][j] = Ao[i][j];

 for (i=0;i<d;i++)
  A[i][d] = bo[i];
/*------------------------------------------------*/
 for (r=0;r<d-1;r++) {
 
 /* in column r find element with max abs value */

  w = Abs(A[r][r]); I = r; 
  for (i=r+1;i<d;i++)
   if (Abs(A[i][r]) > w) w = Abs(A[i][r]), I=i;
/*------------------------------------------------*/
  /* if w==0 ERROR */

  if (w==0) {
   (void) fprintf (stderr,"error in SolveLin: matrix is singular\n");
   (void) fprintf (stderr,"dim = %d\n",d);
   (void) fprintf (stderr,"row = %d\n",r);
   fwritematrix (stderr,"Ao matrix = ", Ao,d,d);
   fwritematrix (stderr,"A  matrix = ", A ,d,d);
   exit (1);
  };
/*------------------------------------------------*/
  /* swap rows r and I */
  if (I > r)
   for (i=r;i<=d;i++) w=A[I][i], A[I][i]=A[r][i], A[r][i]=w;
/*------------------------------------------------*/
                         /* divide line r by Arr */
  a = A[r][r];
  A[r][r] = 1;
  for (i=r+1;i<=d;i++) A[r][i] /= a;
/*------------------------------------------------*/
                          /* make 0's in column r */  
  for (i=r+1;i<d;i++) {
   b = A[i][r];
   A[i][r] = 0;
   for (j=r+1;j<=d;j++) A[i][j] = A[i][j] - b * A[r][j];
  };
 }; /* row */
/*------------------------------------------------*/
 if (A[d-1][d-1] == 0) {
  (void) fprintf (stderr,"error in SolveLin: matrix is singular\n");
  (void) fprintf (stderr,"at the last row\n");
  fwritematrix (stderr,"Ao matrix = ", Ao,d,d);
  fwritematrix (stderr,"A  matrix = ", A ,d,d);
  exit (1);
 };

 /* now A is in upper diagonal form */
/*------------------------------------------------*/
 x[d-1] = A[d-1][d] / A[d-1][d-1];

 for (i=d-2; i>=0; i--) {
  s = 0;
  for (j=i+1;j<d;j++) s +=  A[i][j]*x[j];
  x[i] = A[i][d] - s;
 };
} /* SolveLin */
/************************************************/
void make1matrix (E,d)
  real E [DIM][DIM];
  int d;
  {
   int i,j;

   for (i=0;i<d;i++)
    for (j=0;j<d;j++) E[i][j] = 0;
   for (i=0;i<d;i++)  E[i][i] = 1;
  }  /*  make1matrix  */
/**************************************************/
void make0matrix (E,d)
  real E [DIM][DIM];
  int d;
  {
   int i,j;

   for (i=0;i<d;i++)
    for (j=0;j<d;j++) E[i][j] = 0;
  }  /*  make0matrix  */
/**************************************************/
void makerandmatrix (E,d)
 real E [DIM][DIM];
 int d;
{
 int i,j;

 for (i=0;i<d;i++)
  for (j=0;j<d;j++)
   E[i][j] = (real) myrand3();
}  /*  makerandmatrix  */
/**************************************************/
void makesymrandmatrix (E,d)
 real E [DIM][DIM];
 int d;
{
 int i,j;

 for (i=0;i<d;i++)
  for (j=0;j<=i;j++) {
   E[i][j] = (real) myrand() - 0.5;
   E[j][i] = E[i][j];
  };
}  /*  makesymrandmatrix  */
/***************************************************/
void makezerovector (x,d)
 vector x;
 int d;
{
 int i;

 for (i=0;i<d;i++) x[i]=0;
} /* makezerovector */
/***************************************************/
void sqrvector (x,d)
 vector x;
 int d;
{
 int i;

 for (i=0;i<d;i++) x[i] *= x[i];
} /* sqrvector */
/***************************************************/
void sqrtvector (x,d)
 vector x;
 int d;
{
 int i;

 for (i=0;i<d;i++) x[i] = Sqrt(x[i]);
} /* sqrtvector */
/***************************************************/
void sumnormvector (x,d)
 vector x;
 int d;
{
 int i;
 real s=0;

 for (i=0;i<d;i++) s += x[i];
 for (i=0;i<d;i++) x[i] /= s;
} /* sumnormvector */
/***************************************************/
real norm (x,d)
 vector x;
 int d;
{
 int i;
 real a=0;

 for (i=0;i<d;i++) a += x[i] * x[i];
 a = Sqrt (a);
 return (a);
} /* norm */
/***************************************************/
real anorm (x,d)
 vector x;
 int d;
{
 int i;
 real a=0;

 for (i=0;i<d;i++) a += fabs(x[i]);
 return (a);
} /* anorm */
/***************************************************/
real matrixnorm (A,d1,d2)
 matrix A;
 int d1,d2;
{
 int i,j; 
 real r = 0;

 for (i=0;i<d1;i++) 
 for (j=0;j<d2;j++) 
  r += A[i][j] * A[i][j];
 return (Sqrt(r));
} /* matrixnorm */
/***************************************************/
void difference  (x,y,d)
 real *x,*y;
 int d;
 {
  int i;

  for (i=0;i<d;i++) x[i] -= y[i];
 } /* difference */
 /***************************************************/
 real distance (x,y,d)
 real *x,*y;
 int d;
 {
  real wv [DIM];

  copy (wv,x,d);
  difference (wv,y,d);
  return (norm (wv,d));

 } /* distance */
/***************************************************/
real adistance (x,y,d)
 real *x,*y;
 int d;
{
 int i;
 real s=0;

 for (i=0;i<d;i++) s += fabs(x[i]-y[i]);
 return (s);
} /* adistance */

/***************************************************/
void normalize (x,d)
 real *x;
 int d;
{
 real a;
 int i;

 a = norm (x,d);
 for (i=0;i<d;i++) x[i] /= a;
} /* normalize */
/***************************************************/
void anormalize (x,d)
 real *x;
 int d;
{
 real a;
 int i;

 a = anorm (x,d);
 for (i=0;i<d;i++) x[i] /= a;
} /* anormalize */
/***************************************************/
real scalprod (x,y,d)
 real x[],y[];
 int d;
{
 int i;
 real w;

 w = 0;
 for(i=0;i<d;i++)w+=x[i]*y[i];
 return (w);
} /* scalprod */
/************************************************/
real findangle  (x,y,d)
 vector x,y;
 int d;
{
 real
  a  = norm(x,d),
  b  = norm(y,d),
  ab = scalprod(x,y,d),
  w  = ab/a/b;
 
 if (w >  1) w =  1;
 if (w < -1) w = -1;
 return (acos(w));
} /* findangle */
/************************************************/
void transpose (a,b,d)
 real a[DIM][DIM],b[DIM][DIM];
 int d;
{
 int i,j;

 for (i=0;i<d;i++)
 for (j=0;j<d;j++) 
  a[i][j] = b[j][i];
} /* transpose */
/***********************************/
/*******************************************/
void allocdata (x,n)
 real **x;
 long n;
{
 static long ncalled = 0;

 if (debug) called ("allocdata",&ncalled);

 *x=(real*) calloc ((size_t)n,(size_t)sizeof(real));
 if (*x==NULL) {
  (void) fprintf (stderr,
   "error in allocdata : \
     cannot allocate memory for %ld reals",n);
  exit (1);
 };

 if (debug) leave ("allocdata");
} /* allocdata */
/*********************************************/
void alloclong (x,n)
 long **x;
 long n;
{
 *x=(long*) calloc ((size_t)n,(size_t)sizeof(long));
 if (*x==NULL) {
  (void) fprintf (stderr,
   "error in alloclong : cannot allocate memory for %ld longs",n);
  exit (1);
 };
} /* alloclong */
/*******************************************/
/*******************************************/
void er (s)
 char *s;
{
 (void) fprintf (stderr," error : %s \n",s);
 exit (1);
} /* er */
/************************************************/
void erp ()
{
 er ("reading paramfile");
} /* erp */
/*******************************************/
void freaddata (x,n,f)
 real **x;
 long *n;
 FILE *f;
{
# define N 10000
 long i=0;
 real w;
 static long ncalled = 0;

 if (debug) called ("freaddata",&ncalled);

 *n = N;
 if (debug) (void) fprintf (stderr,"n = %ld\n",*n);
 allocdata (x,*n);

 while (fscanf(f,"%lf",&w)==1) {

  if (debug) (void) fprintf (stderr,
   "i = %8ld  w = %G \n",i, w);

  if (i==*n) *x = (real*) realloc 
   ((void*)*x, (size_t) ((*n+=N) * sizeof(real)) );
 
  (*x)[i++] = w;
 };
 if (i < *n) {
  *n = i;
  *x = (real*) realloc 
   ((void*)*x, (size_t) ((*n) * sizeof(real)) );
 };
 (void) fclose (f);

 if (*n == 0) er ("empty input file");

 if (debug) leave ("freaddata");
# undef N
} /* freaddata */
/*******************************************/
void readdata (x,n,s)
 real **x;
 long *n;
 char *s;
{
 FILE *f;

 ppopenr (&f,s);
 freaddata (x,n,f);
 (void) fclose (f);
} /* readdata */
/*******************************************/
/*******************************************/
int Round (wx)
 real  wx;
{
 int y;

 if (wx >= 0) y = (int) (wx + 0.5);
 else         y = (int) (wx - 0.5);

 return (y);
} /* Round */
/*******************************************/
long Roundl (wx)
 real  wx;
{
 long y;

 if (wx >= 0) y = (long) (wx + 0.5);
 else         y = (long) (wx - 0.5);

 return (y);
} /* Roundl */
/*******************************************/
void readmatrix (A,d,s)
 matrix A;
 int *d;
 char *s;
{
 int i,j;
 real *x;
 long n;

 readdata (&x,&n,s);
 *d = Round ( Sqrt (n) );

 if (*d > DIM) {
  (void) fprintf (stderr,
   "sorry, dim = %1d > maxdim = %1d\n", *d,DIM);
  exit (0);
 };

 for (i=0;i<*d;i++)
 for (j=0;j<*d;j++)
  A[i][j] = x [i * *d + j];
 (void) free ((void*)x);
} /* readmatrix */
/***********************************/
void extractdiag (x,A,d)
 vector x;
 matrix A;
 int d;
{
 int i;

 for (i=0;i<d;i++)
  x[i] = A[i][i];
} /* extractdiag */
/***********************************/
/***********************************/
void rk (x0,yo,h0,eps0,y,ah,aeps,F,p,d)
 real x0,yo[],h0,eps0,y[],*ah,*aeps;
 void (*F)();
 vector p;
 int d;
 {
  int i;
  real f  [DIM],
         k1 [DIM],
         k2 [DIM],
         k3 [DIM],
         k4 [DIM],
         k5 [DIM],
         yl [DIM],
         y2 [DIM],
         y3 [DIM],
         y4 [DIM],
         y5 [DIM],
         eps,h;
  static int nrk = 0;
  real g[DIM],J[DIM][DIM];
  static long ncalled = 0;

 if (debug>2) {
  called ("rk",&ncalled);
  (void)fprintf(stderr,"x0   = %G\n",x0);
  fwritevector (stderr,"yo   = ",yo,d);
  (void)fprintf(stderr,"h0   = %G\n",h0);
  (void)fprintf(stderr,"eps0 = %G\n",eps0);
 };

 nrk++;
 F(x0,yo,p, f,g,J, d);
 for (i=0; i<d; i++) k1[i] = h0 * f[i];
 for (i=0; i<d; i++) yl[i] = yo[i] + k1[i] / 3;
 F(x0+h0/3,yl ,p, f,g,J, d);
 for (i=0; i<d; i++) k2[i] = h0 * f[i];
 for (i=0; i<d; i++) y2[i] = yo[i] + (k1[i]+k2[i]) / 6;
 F(x0+h0/3,y2,p, f,g,J, d);
 for (i=0; i<d; i++) k3[i] = h0 * f[i];
 for (i=0; i<d; i++) y3[i] = yo[i]+0.125*k1[i]+0.375*k3[i];
 F(x0+h0/2,y3,p, f,g,J, d);
 for (i=0; i<d; i++) k4[i] = h0 * f[i];
 for (i=0; i<d; i++) y4[i] = yo[i]+0.5*k1[i]-1.5*k3[i]+2*k4[i];
 F(x0+h0,y4,p, f,g,J, d);
 for (i=0; i<d; i++) k5[i] = h0 * f[i];
 for (i=0; i<d; i++) y5[i] = yo[i]+(k1[i]+4*k4[i]+k5[i])/6;
 eps = 0;
 for (i=0; i<d; i++) eps += (y4[i]-y5[i]) * 
                            (y4[i]-y5[i]);
 eps = Sqrt (eps) / 5;

 if (debug>2) {
  fwritevector (stderr,"yl   = ",yl ,d);
  fwritevector (stderr,"y2   = ",y2,d);
  fwritevector (stderr,"y3   = ",y3,d);
  fwritevector (stderr,"y4   = ",y4,d);
  fwritevector (stderr,"y5   = ",y5,d);
  (void)fprintf(stderr,"eps  = %G\n",eps );
 };

 if      (eps == 0) h = h0 * 2;
 else if (eps >  0) h = h0 * exp ((double)(Log(eps0/eps)/4));
 else               h = h0 * 0.1;
 if (h/h0 > 2) h = 2 * h0;

 *ah   = h;
 *aeps = eps;
 for (i=0;i<d;i++) y[i] = y5[i];

 if (debug>2) {
   (void)fprintf(stderr,"h    = %G\n",h   );
   leave ("rk");
 };
} /* rk */
/************************************************/
void kub (t0,x0,h,f,g,J,  at,x,d)
 real t0,h;
 vector x0,f,g,x;
 matrix J;
 real *at;
 int d;
{
 real hh2 = h*h/2;
 vector b,v,dx;
 matrix A,B;

 make1matrix (A,d);      /* A = E                         */
 timessm (B,h,J,d,d);    /* B = hJ                        */
 minusmm (A,A,B,d,d);    /* A = E - hJ                    */
 timesmm (B,J,J,d,d,d);  /* B = J.J                       */
 timessm (B,hh2,B,d,d);  /* B = h^2/2 J.J                 */
 plusmm  (A,A,B,d,d);    /* A = E - hJ + h^2/2 J.J        */

 timessv (b,h,f,d);      /* b = h f                       */
 timesmv (v,J,f,d,d);    /* v = J.f                       */
 timessv (v,hh2,v,d);    /* v = h^2/2 J.f                 */
 minusvv (b,b,v,d);      /* b = h f - h^2/2 J.f           */
 timessv (v,hh2,g,d);    /* v = h^2/2 g                   */
 plusvv  (b,b,v,d);      /* b = h f - h^2/2 J.f + h^2/2 g */

 SolveLin (A,dx,b,d);
 plusvv  (x,x0,dx,d);    /* x = x0 + dx                   */
 *at = t0 + h;
}  /*  kub  */
/**************************************************/
void  kub3e (t0,x0,h0,eps0, x,ah,aeps,F,p,d)
  /*  pars like in rk  */
  real t0,x0[DIM],h0,eps0;
  real x[DIM],*ah,*aeps;
  void (*F)();
  vector p;
  int d;
  {
   real h2 = h0/2, t1,t2,t3, eps,h;
   vector wv, x1,x2,x3, f0,f2, g0,g2;
   matrix J0,J2;

   F (t0,x0,p, f0,g0,J0, d);
   kub (t0,x0,h0,f0,g0,J0,&t1,x1,d);
   kub (t0,x0,h2,f0,g0,J0,&t2,x2,d);
   F (t2,x2,p, f2,g2,J2, d);
   kub (t2,x2,h2,f2,g2,J2,&t3,x3,d);

   timessv (wv,(real)-4.0 ,x3,d);
   plusvv  (wv,x1   ,wv,d);
   timessv (x ,(real)(-1/3.),wv,d);

   eps = distance (x1,x3,d);

   if      (eps == 0) h = h0 * 2;
   else if (eps >  0) h = h0 * exp ((double)(Log(eps0/eps)/3));
   else               h = h0 * 0.1;
   if (h/h0 > 2) h = 2 * h0;

   *ah   = h;
   *aeps = eps;
  }  /*  kub3e  */
/**************************************************/
void grk (xo,yo,y,h,f,p,d) /* general Runge-Kutta */
 real xo;
 vector yo,y;
 real h;
 vector p;
 int d;
 void (*f)();
/* Hut Runge-Kutta method 
   Vitasek
   order = 6
   local error = O(h^7)
*/
{
# define S 8
 static real 
  a [S] = {0,1,1,1,1,2,5,1},
  aa[S] = {1,9,6,3,2,3,6,1},
  b [S][S] = {{   1},
              {   1,    3},
              {   1,   -3,   4},
              {  -5,   27, -24,   6},
              { 221, -981, 867,-102,   1},
              {-183,  678,-472, -66,  80, 3},
              { 716,-2079,1002, 834,-454,-9, 72},
              {  41,    0, 216,  27, 272,27,216, 41}},
  bb[S] =     {   9,   24,   6,   8,   9,48, 82,840};
 real x,w,k[S][S];
 int s,n,i;
 vector g;
 matrix J;
 static long ncalled = 0;

 if (debug) {
  called ("grk",&ncalled); 
  (void) fprintf (stderr,"xo = %G\n",xo);
  fwritevector (stderr,"yo = \n",yo,d);
 };

 for (i=0;i<d;i++) y[i] = yo[i];

 for (s=0;s<S;s++) {
  x = xo + h * a[s]/aa[s];
  f (x,y,p, k[s],g,J, d);
   
  for (i=0;i<d;i++) {
   w = 0; for (n=0;n<=s;n++) w += b[s][n]*k[n][i];
   y[i] = yo[i] + h * w / bb[s];
  };
 };
 if (debug) leave ("grk");
# undef S
} /* grk */
/**************************************************/
void rkr (x,yo,y,e,h,f,p,d) /* Runge-Kutta Richardson */
 real x;
 vector yo,y;
 real *e,h;
 vector p;
 int d;
 void (*f)();
{
 vector yl,y2,y3;
 int i;
 real w;
 static long ncalled = 0;

 if (debug) {
  called ("rkr",&ncalled);
  (void) fprintf (stderr,"x  = %G\n",x );
  fwritevector (stderr,"yo = \n",yo,d);
 };


 grk (x    ,yo,yl,h  ,f,p,d);
 grk (x    ,yo,y2,h/2,f,p,d);
 grk (x+h/2,y2,y3,h/2,f,p,d);

 w = 0;
 for (i=0;i<d;i++) {
  y[i] = (64*y3[i]-yl[i]) / 63;
  w += (yl[i]-y3[i]) * (yl[i]-y3[i]);
 };
 *e = Sqrt (w);
 if (debug) leave ("rkr");
} /* rkr */
/**************************************************/
void prk (t0,x0,h0,eps0, x,ah,aeps,f,p,d)
 /*  pars like in rk  */
 real t0,x0[DIM],h0,eps0;
 real x[DIM],*ah,*aeps;
 void (*f)();
 vector p;
 int d;
{
 real  eps,h;
 static long ncalled = 0;

 if (debug) {
  called ("prk",&ncalled);
  (void) fprintf (stderr,"t0 = %G\n",t0);
  fwritevector (stderr,"x0 = \n",x0,d);
 };

 rkr (t0,x0,x,&eps,h0,f,p,d);

 if      (eps == 0) h = h0 * 2;
 else if (eps >  0) h = h0 * exp (log((double)(eps0/eps))/7);
 else               h = h0 * 0.1;
 if (h/h0 > 2) h = 2 * h0;

 *ah   = h;
 *aeps = eps;
 if (debug) {
  (void) fprintf (stderr,"\neps = %G\n",eps);
  (void) fprintf (stderr,"h0   = %G\n",h0);
  (void) fprintf (stderr,"h    = %G\n",h );
  leave ("prk");
 };
}  /*  prk */
/**************************************************/
void checkstep (ax0,yo,ah0,acor,f,p,d)
 real *ax0,*ah0;
 void (*f)();
 vector yo,p;
 int *acor,d;
{
 vector y;
 real h,e, hmax = 10;
 int i,iter=0,itermax=10;
 static int nerout=0, neroutmax = 10;
 static long ncalled = 0;

 if (debug>2) {
  called ("checkstep",&ncalled);
  (void) fprintf (stderr,"to = %G\n",(double)*ax0);
  (void) fprintf (stderr,"yo =");
  for(i=0;i<d;i++)
   (void)fprintf(stderr,"%G ",(double)yo[i]);
  (void) fprintf (stderr,"\n");
  (void) fprintf (stderr,"ho = %G\n",(double)*ah0);
 };

 h = *ah0;

 do {
  *ah0  = h / ++iter;

  switch (intmethod) {
   case FAST   :
    rk   (*ax0,yo,*ah0,geps0,y,&h,&e,f,p,d); break;
   case STIFF  :
    kub3e(*ax0,yo,*ah0,geps0,y,&h,&e,f,p,d); break;
   case PRECISE:
    prk  (*ax0,yo,*ah0,geps0,y,&h,&e,f,p,d); break;
  };

  if (debug>2) (void) fprintf (stderr,
   "iter = %2d h0 = %G h = %G e = %G\n",
   iter, (double)*ah0, (double)h, (double)e);

  if (!debug && iter > itermax && nerout < neroutmax) {
   nerout++;
   if (nerout==neroutmax)
    (void) fprintf (stderr, "\nfurther output on \
         checkstep konvergence suppressed\n\n");
   else {
    (void) fprintf (stderr, "\ncheckstep warning \n");
    (void) fprintf (stderr,"iter  = %d \n",iter);
    (void) fprintf (stderr,"e     = %G \n",(double)e);
    (void) fprintf (stderr,"geps0 = %G \n",(double)geps0);
    (void) fprintf (stderr,"t     = %.10G \n",(double)*ax0);
    for(i=0;i<d;i++)
    (void) fprintf (stderr,"x[%1d]  = %.10G \n",i,(double)yo[i]);
    for(i=0;i<6;i++)
    (void) fprintf (stderr,"p[%1d]  = %.10G \n",i,(double)p [i]);
    (void) fprintf (stderr,"h0    = %G \n",(double)*ah0);
    (void) fprintf (stderr,"h     = %G \n",(double)  h );
   };
  };
 } while (!(e < 10 * geps0));  /* repeat also if NaN (not a number) */

 for (i=0;i<d;i++) yo[i] = y[i];
 (*ax0) += (*ah0); 
 if (Abs(h) > hmax) h = hmax * Abs(h) / h;
 if (gprinth) (void) fprintf (stderr,"%G\n",h);
 *ah0  = h;
 *acor = iter-1;
 if (*acor > globcormax) globcormax = *acor;

 if (debug>2) {
  (void) fprintf (stderr,"t  = %.15G\n",(double)*ax0);
  (void) fprintf (stderr,"y  = ");
  for(i=0;i<d;i++)
   (void)fprintf(stderr,"%.15G\n",(double)yo[i]);
  (void) fprintf (stderr,"\n");
  (void) fprintf (stderr,"h  = %.15G\n",(double)*ah0);
  leave ("checkstep");
 };
} /* checkstep */
/************************************************/
/************************************************/
void integ1h (at,y,f,p,d)
  real *at,y[];
  void (*f)();
  vector p;
  int d;
 {
  extern real gh0;
  int cor;
  static long ncalled = 0;

 if (debug) called ("integ1h",&ncalled);

 checkstep (at ,y  ,&gh0 ,&cor,f,p,d);
 if (debug) leave ("integ1h");
 } /* integ1h */
 /**************************************************/
void integnh (at,y,f,p,d,n)
  real *at,y[];
  void (*f)();
  vector p;
  int d,n;
 {
  extern real gh0;
  int i,cor;
  static long ncalled = 0;

 if (debug) called ("integnh",&ncalled);
 for (i=0;i<n;i++) checkstep (at ,y  ,&gh0 ,&cor,f,p,d);
 if (debug) leave ("integnh");
 } /* integnh */
/**************************************************/
void  integdt (t,T,y,f,p,d)
  real y[],*t,T;
  void (*f)();
  vector p;
  int d;
 {
  real tmax = *t+T;
  extern real gh0;
  int cor;

  if (T > 0) {
   if (gh0 < 0) gh0 = -gh0;

   while ((*t+gh0) < tmax) {
    checkstep (t ,y  ,&gh0 ,&cor,f,p,d);
   }
   do {
    gh0 = tmax - *t;
    checkstep (t ,y  ,&gh0 ,&cor,f,p,d);
   }
   while (cor);
  };
 } /* integdt */
 /**************************************************/
void  integdtb (t,T,y,f,p,d)
  real y[],*t,T;
  void (*f)();
  vector p;
  int d;
 {
  real tend = *t-T;
  extern real gh0;
  int cor;

  if (gh0 > 0) gh0 = -gh0;

  while ((*t+gh0) > tend) {
   checkstep (t ,y  ,&gh0 ,&cor,f,p,d);
  }
  do {
   gh0 = tend - *t;
   checkstep (t ,y  ,&gh0 ,&cor,f,p,d);
  }
  while (cor);
 } /* integdtb */
/**************************************************/
void  integdte (t,T,y,pne,f,p,d)
  real *t,T,y[];
  void (*f)();
  vector p;
  int *pne,d;
 {
  real  tmax = *t + T,
         ay2 = 4,
         ay1 = 3,
         ay;
  extern real gh0;
  int cor;
  static int yf=1;

  while ((*t+gh0) < tmax) {
   checkstep (t ,y  ,&gh0 ,&cor,f,p,d);
   ay = y[1];
   if ((yf==1)&&(ay<ay1)) (*pne)++;
   if (ay>ay2) yf=1;
   if (ay<ay1) yf=0;
  }
  do {
   gh0 = tmax - *t;
   checkstep (t ,y  ,&gh0 ,&cor,f,p,d);
   ay = y[1];
   if ((yf==1)&&(ay<ay1)) (*pne)++;
   if (ay>ay2) yf=1;
   if (ay<ay1) yf=0;
  } while (cor);
 } /* integdte */
/**************************************************/
/**************************************************/
void  subdet (S,A,d,m,n)
 real S[DIM][DIM],
        A[DIM][DIM];
 int d,m,n;
 {
  int i,j,di,dj;

  di = 0;
  for(i=0;i<d-1;i++){
   if(i==m)di=1;
   dj=0;
   for(j=0;j<d-1;j++){
    if(j==n)dj=1;
    S[i][j] = A[i+di][j+dj];
   };
  }
 } /* subdet */
/************************************************/
real det (A,d)
 matrix A;
 int d;
{
 real w=0;
 matrix S;
 int s=1,i,j=0;

 if (d==1) w = A[0][0];
 else if (d==2) w = A[0][0]*A[1][1]-A[0][1]*A[1][0];
 else if (d==3) w =  
  -A[0][2]*A[1][1]*A[2][0] + A[0][1]*A[1][2]*A[2][0] + 
   A[0][2]*A[1][0]*A[2][1] - A[0][0]*A[1][2]*A[2][1] - 
   A[0][1]*A[1][0]*A[2][2] + A[0][0]*A[1][1]*A[2][2];
 else {
  for(i=0;i<d;i++){
   subdet (S,A,d,i,j);
   w += s * A[i][j] * det (S,d-1);
   s *= -1;
  };
 };
 return (w);
} /* det */
/**************************************************/
void  outer (z,A,d)
 real A[DIM][DIM],z[DIM];
 int d;
 {
  real S[DIM][DIM];
  int s=1,i=d-1,j;

  for(j=0;j<d;j++){
   subdet (S,A,d,i,j);
   z[j] = s * det (S,d-1);
   s *= -1;
  };
 } /* outer */
/**************************************************/
void jacob (J,pf,x0,d)
 real J [DIM][DIM],x0[];
 int (*pf)(),d;
{
  int i,j;
  real dx,
         xw  [DIM],
         y00 [DIM],
         yw  [DIM];

  for(i=0;i<d;i++) xw[i] = x0[i];
  (*pf) (x0,y00,d);
  for(j=0;j<d;j++){
   dx = 1E-8 + 1E-5 *Abs(xw[j]);
   xw[j] += dx;
   (*pf) (xw,yw,d);
   xw[j] = x0[j];
   for(i=0;i<d;i++)
    J[i][j] = (yw[i]-y00[i]) / dx;
  };
 } /* jacob */
 /************************************************/
int newton (x,pf,pfjac,d)
 vector x;
 int (*pf)(),(*pfjac)(),d;
{
 int i,ii,n=0,nmax = 100,nsign=1;
 vector dx,x0,y,y00;
 matrix J;
 real w,ay,ay0;
 static long ncalled = 0;
 real adetJ,k1,k2,amin,amax;
 vector Jnorms;

 if (debug) called ("newton",&ncalled);

 copy (x0,x,d);
 (*pf) (x0,y00,d);
 
 ay0 = norm (y00,d);

 if (debug) {
  writevector ("x0 = ",x0,d);
  writevector ("y0 = ",y00,d);
  wrlf ("norm y0 = ",ay0);
 };

 if (pfjac) pfjac (x0,J,d);
 else jacob (J,pf,x0,d);

 adetJ = Abs (det (J,d));
 for (i=0;i<d;i++) Jnorms[i] = norm (J[i],d);

 w = 1;
 for (i=0;i<d;i++) w *= Jnorms[i];
 k1 = adetJ / w;

 amin = Jnorms [0];
 amax = Jnorms [0];
 for (i=1;i<d;i++) {
  if (Jnorms [i] < amin) amin = Jnorms[i];
  if (Jnorms [i] > amax) amax = Jnorms[i];
 }; 
 k2 = amin / amax;

 if (debug) {
  wrlf ("adetJ = ",adetJ);
  wrlf ("k1    = ",k1);
  wrlf ("k2    = ",k2);
 };

 if (k1 > 1E-3 && k2 > 1E-3) {
  SolveLin (J,dx,y00,d);
/*  invmat (J,d); timesmv (dx,J,y00,d,d); */
  if (debug) writematrix ("J inv = ",J,d,d);
 } 
 else {
  nsign = -1;
  ii = 0;
  w = Abs (y00[ii]);
  for (i=1;i<d;i++)
   if (Abs (y00[i]) > w) {ii=i;w=Abs (y00[i]);};

  w = 0;
  for (i=0;i<d;i++) w += J [ii][i] * J [ii][i];
  w = y00[ii] / w;
  timessv (dx,w,J [ii], d);
 };
 if (debug) writevector ("dx    = ",dx,d);

 do {
  n++;
  minusvv (x,x0,dx,d);
  (*pf) (x,y,d);
  ay = norm (y,d);
  timessv (dx,0.5,dx,d);
 } while ( ay > ay0 && ay > 1000 * EPS && n < nmax );

 if (n == nmax) er ("Newton not converging");
 if (debug){
  (void) fprintf (stderr,"n = %d\n",n);
  fwritevector (stderr,"x = ",x,d);
  (void) fprintf(stderr,"residuum = %G\n",ay);
  leave ("newton");
 };
 return (nsign*n);
} /* newton */
 /************************************************/
void grad (g,pf,x0,d)
 real g [],x0[],(*pf)();
 int d;
 {
  int j;
  real dx, xw [DIM], y00, yw;

  for(j=0;j<d;j++) xw[j] = x0[j];
  y00 = (*pf) (x0);
  for(j=0;j<d;j++){
   dx = 1E-8 + 1E-5 *Abs(xw[j]);
   xw[j] += dx;
   yw = (*pf) (xw);
   xw[j] = x0[j];
   g[j] = (yw-y00) / dx;
  };
 } /* grad */
/***************************************************/
int in (x,x1,x2,d)
 real *x,*x1,*x2;
 int d;
{
 int i,iw = 1;

 for (i=0; (i<d) && iw; i++)
  iw = iw && ((x[i]-x1[i])*(x[i]-x2[i]) <= 0);
 return (iw);
} /* in */
/***************************************************/
void tangent (t,x,f,d)
 real *t,*x;
 int (*f)();
 int d;
{
 real J [DIM][DIM],
        S [DIM][DIM];
 extern real det ();

 int i, sign = 1;
 static long ncalled = 0;

 if (debug) called ("tangent",&ncalled);
 jacob (J,f,x,d);
 for (i=0;i<d;i++) {
  subdet (S,J,d,d-1,i);
  t[i] = sign * det (S,d-1);
  sign *= -1;
 };
 if (debug) leave ("tangent");
} /* tangent */
/************************************************/
void solve2alg (x,a)
 real x[4],a[3];
{
 real d = a[1] * a[1] - 4 * a[2] * a[0];

 if (d>=0) {
  x[0] = (-a[1] + Sqrt (d)) / (2*a[2]);
  x[1] = 0;
  x[2] = (-a[1] - Sqrt (d)) / (2*a[2]);
  x[3] = 0;
 }
 else {
  x[0] = - a[1]    / (2 * a[2]);
  x[1] = Sqrt (-d) / (2 * a[2]);
  x[2] = x[0];
  x[3] = - x[1];
 };
} /* solve2alg */
/************************************************/
void eigv2 (eig,j)
 real eig[4],j[DIM][DIM];
{
 real Tr,Det,a[3];

 Tr = j[0][0] + j[1][1];
 Det = j[0][0] * j[1][1] - j[0][1] * j[1][0];
 a[0] = Det;
 a[1] = - Tr;
 a[2] = 1;
 solve2alg (eig,a);
} /* eigv2 */
/************************************************/
/************************************************/
/*
HP-UX  9.05 cc cbrt was wrong 
HP-UX 10.20 cc cbrt is correct 
*/
/************************************************/
double mycbrt (x)
 double x;
{
 if      (x == 0.0) return (0.0);
 else if (x >  0.0) return ( exp(log( x)/3));
 else               return (-exp(log(-x)/3));
} /* mycbrt */
/************************************************/
/************************************************/
/*
 2.7.2.3 gcc did not link acosh and asinh
 2.8.0   gcc does 
*/
/************************************************/
double myacosh (x)
 double x;
{
 if (x<1) return (1.0);
 else     return (log(x+Sqrt(x*x-1)));
} /* myacosh */
/***********************************************/
double myasinh (x)
 double x;
{
 return (log(x+Sqrt(x*x+1)));
} /* myasinh */
/***********************************************/
void solve3alg (x,C)
  vector x,C;
{
  real a,a2,a3,b,b2,b3,c,d,p,p2,p3,q,D,e=1,
  ry1=0,iy1=0,ry2=0,iy2=0,ry3=0,iy3=0,s,r,fi3,rsinhfi3,rcoshfi3,w;

  if(debug)(void)fprintf(stderr,"solve3alg called\n\n");
  a  = C[3];
  b  = C[2];
  c  = C[1];
  d  = C[0];
  a2 = a*a;
  a3 = a*a2;
  b2 = b*b;
  b3 = b*b2;
  
  p  = (3*a*c-b2)/(9*a2);
  p2 = p*p;
  p3 = p*p2;
  q  = (2*b3 - 9*a*b*c + 27*a2*d)/(54*a3);
  D  = -p3-q*q;

/*--------------------------------------------*/
  if (q==0) {
    if (debug) (void) fprintf (stderr,"vetev A\n");
    if (p> 0) {iy2=Sqrt( 3*p); iy3= -iy2;};
    if (p< 0) {ry2=Sqrt(-3*p); ry3= -ry2;};
  }
/*--------------------------------------------*/
  else if (p==0) {
    if (debug) (void) fprintf (stderr,"vetev B\n");
    if (q!=0) {
     ry1 = cbrt(-2*q);
     ry2=ry3= -0.5*ry1; iy2=ry1*Sqrt(3.0)/2; iy3= -iy2;
    };
  }
/*--------------------------------------------*/
  else {
    if (q < 0) e = -1;
    r = e * Sqrt(Abs(p));
    w   = q/(r*r*r);

    if (p<0) {
      if (D >= 0) {
        if (debug) (void) fprintf (stderr,"vetev C\n");
        if (w>1) fi3 = 0;
        else     fi3 = acos (w) / 3;
        ry1 = -2*r*cos(fi3);
        ry2 = 2*r*cos(Pi/3-fi3);
        ry3 = -ry1-ry2;
      } else {
        if (debug) (void) fprintf (stderr,"vetev D\n");
        if (w<1) fi3 = 0;
        else     fi3 = acosh (w) / 3;
        rcoshfi3 = r*cosh(fi3);
        ry1 = -2*rcoshfi3;
        ry2 = rcoshfi3;
        iy2 = Sqrt(3.0)*r*sinh(fi3);
        ry3 = -ry1-ry2;
        iy3 = -iy1-iy2;
      }
    }

    else {
      if (debug) (void) fprintf (stderr,"vetev E\n");
      fi3 = asinh(w) / 3;
      rsinhfi3 = r*sinh(fi3);
      ry1 = -2*rsinhfi3;
      ry2 = rsinhfi3;
      iy2 = Sqrt(3.0)*r*cosh(fi3);
      ry3 = -ry1-ry2;
      iy3 = -iy1-iy2;
    }
  };
/*--------------------------------------------*/
  if (iy2<iy3) {
   w=iy2; iy2=iy3; iy3=w;
   w=ry2; ry2=ry3; ry3=w;
  };
  s = b/(3*a);
  x[0] = ry1 - s;
  x[1] = iy1;
  x[2] = ry2 - s;
  x[3] = iy2;
  x[4] = ry3 - s;
  x[5] = iy3;

  if (debug) {
   (void) fprintf (stderr,"a = %G\n",a);
   (void) fprintf (stderr,"b = %G\n",b);
   (void) fprintf (stderr,"c = %G\n",c);
   (void) fprintf (stderr,"d = %G\n\n",d);
   (void) fprintf (stderr,"p = %.16G\n",p);
   (void) fprintf (stderr,"q = %.16G\n",q);
   (void) fprintf (stderr,"D = %.16G\n\n",D);
   (void) fprintf (stderr,"ry1 = %G\n",ry1);
   (void) fprintf (stderr,"iy1 = %G\n",iy1);
   (void) fprintf (stderr,"ry2 = %G\n",ry2);
   (void) fprintf (stderr,"iy2 = %G\n",iy2);
   (void) fprintf (stderr,"ry3 = %G\n",ry3);
   (void) fprintf (stderr,"iy3 = %G\n\n",iy3);
   (void) fprintf (stderr,"solve3arg O.K.\n\n");
  };
} /* solve3alg */
/************************************************/
void make_char_eqn3 (C,J)
 vector C;
 matrix J;
{
 C[0] =   J[0][0]*J[1][1]*J[2][2]
         +J[0][1]*J[1][2]*J[2][0]
         +J[0][2]*J[1][0]*J[2][1]
         -J[0][0]*J[1][2]*J[2][1]
         -J[0][1]*J[1][0]*J[2][2]
         -J[0][2]*J[1][1]*J[2][0];
 C[1] =   J[0][1]*J[1][0]
        - J[0][0]*J[1][1]
        + J[0][2]*J[2][0] 
        + J[1][2]*J[2][1]
        - J[0][0]*J[2][2] 
        - J[1][1]*J[2][2];
 C[2] =   J[0][0] + J[1][1] + J[2][2];
 C[3] = -1;
} /* make_char_eqn3 */
/************************************************/
void eigenvalues3 (e,J)
 vector e;
 matrix J;
{
 vector C;

 make_char_eqn3 (C,J);
 solve3alg (e,C);
} /* eigenvalues3 */
/**************************************/
/**************************************/
void setstac (y,T,f,p,d)
 real y[],T;
 void (*f)();
 vector p;
 int d;
{
 static long ncalled = 0;
 static vector gystac;
 real t=0;

 if (!ncalled) {
  ncalled = 1;
  y [0] = 5.5; 
  y [1] = 6.4; 
  integdt (&t,T,y,f,p,d);
  copy (gystac,y,d);
 }
 else copy (y,gystac,d);
} /* setstac */
/**************************************/
void perturbation (y,A)
 real y[],A;
{
 y[0] += A;
/* y[0] = pow (10.0,-(A-log10(y[0]))); */
} /* perturbation */
/**************************************************/
/**************************************/
void oneyear (y,T,A,pne,f,p,d)
 real *y,T,A;
 void (*f)();
 vector p;
 int *pne,d;
{
 real t = 0;

 seth0(1E-5);
 perturbation (y,A);
 integdte (&t,T,y,pne,f,p,d);

/* alfa = alfa1;
 integdte (T/2,y,pne);
 alfa = alfa2;
 integdte (T/2,y,pne);
*/
} /* oneyear */
/**************************************/
real rotrat (T,A,f,p,d)
 real T,A;
 void (*f)();
 vector p;
 int d;
{
#define SDIM 10000
 extern real distance ();
 struct {real c[DIM];int ne;} s [SDIM];
 real y[DIM],
        epsy = 1E-3, /* to close a cycle */
        w,r,
        dist;

 int n  = 0,  /* current point    */
     ne = 0,  /* # excitations    */
     nn,      /* nearest neighbor */
     i,       /* coordinate index */
     j,       /* to find nearest neighbor */
     Ne,Np;

 setstac (y,(real)200.0,f,p,d);

 do{
  for(i=0;i<d;i++)(s[n].c)[i]=y[i];
  s[n].ne = ne;
  n++;
   
  oneyear (y,T,A,&ne,f,p,d);

  dist = distance (y,s[0].c,d);
  nn   = 0;
  for(j=1;j<n;j++){
   w = distance (y,s[j].c,d);
   if (w < dist) {dist = w; nn = j;};
  };

 }while ((dist > epsy)&&(n < SDIM));

 Ne = ne - s[nn].ne;
 Np = n  - nn;
 r  = (real) Ne / Np;
 return (r);
# undef SDIM
} /* rotrat */
/**************************************************/
/**************************************************/
 long wc (f)
 FILE *f;
 {
  long n = 0;
  int c;

  c=getc(f);
  do{
   while((c==' ')||(c=='\t')||(c=='\n'))c=getc(f);
   if(c!=EOF)n++;
   while((c!=' ')&&(c!='\t')&&(c!='\n')&&(c!=EOF))
    c=getc(f);
  }while(c!=EOF);
  rewind (f);
  return (n);
 } /* wc */
/**************************************************/
/**************************************************/
void prepranddata (x,n)
 real *x;
 long n;
{
 long i;

 for (i=0;i<n;i++) x[i] = myrand();
} /* prepranddata */
/*********************************************/
void prepndata (x,n)
 real **x;
 long n;
{
 long i;

 allocdata (x,n);
 for (i=0;i<n;i++) (*x)[i] = (real) i;
} /* prepndata */
/*********************************************/
void printdata (x,n)
 real *x;
 long n;
{
 long i;
 
 for (i=0;i<n;i++) (void) printf ("%.15G\n",(double)x[i]);
} /* printdata */
/*********************************************/
void sprintdata (x,n,s)
 real *x;
 long n;
 char* s;
{
 long i;
 FILE *f;

 ppopenww (&f,s);
 for(i=0;i<n;i++) (void)fprintf(f,"%.15G\n",(double)x[i]);
 (void)fclose(f);
} /* sprintdata */
/*********************************************/
void sprintldata (x,n,s)
 long *x,n;
 char* s;
{
 long i;
 FILE *f;

 ppopenww (&f,s);
 for(i=0;i<n;i++) 
  (void) fprintf
   (f,"%ld\n",
    x[i]);
 (void)fclose(f);
} /* sprintidata */
/*********************************************/
void print2data (x,y,n)
 real *x,*y;
 long n;
{
 long i;

 for (i=0;i<n;i++)
  (void) printf ("%.15G %.15G\n",(double)x[i],(double)y[i]);
} /* print2data */
/*********************************************/
void revdata (x,n)
 real *x;
 long n;
{
 long i,j;
 real w;

 for (i=0, j = n-1; i<n/2; i++,j--){
  w    = x[i];
  x[i] = x[j];
  x[j] = w;
 };
} /* revdata */
/*********************************************/
void revmatrix (A,d)
 matrix A;
 int d;
{
 int i,j;
 vector w;

 for (i=0, j = d-1; i<d/2; i++,j--){
  copy (w   ,A[i],d);
  copy (A[i],A[j],d);
  copy (A[j],w   ,d);
 };
} /* revmatrix */
/*********************************************/
void logdata (x,n)
 real *x;
 long n;
{
 long i;

 for (i=0;i<n;i++) x[i] = log10 (fabs ((double)x[i]));
} /* logdata */
/*********************************************/
void centerdata (x,n)
 real *x;
 long n;
{
 long i;
 real w=0;

 for (i=0;i<n;i++) w += x[i];
 w /= n;
 for (i=0;i<n;i++) x[i] -= w;
} /* centerdata */
/*********************************************/
void windowdata (x,n)
 real *x;
 long n;
{
 long i;
 real w;

 for (i=0;i<n;i++) {
  w = i / (real)n ; /* 0 ... 1 */
  w = (1-Cos(twoPi*w))/2;
  x[i] *= w;
 };
} /* windowdata  */
/*********************************************/
void subsortdata (x,l,r)
 real *x;
 long l,r;
{
 long i=l,j=r;
 real v,w;

 v = x[(l+r)/2];
 do {
  while (x[i]<v) i++;
  while (x[j]>v) j--;
  if (i<=j) {
   w = x[i];
   x[i] = x[j];
   x[j] = w;
   i++;
   j--;
  };
 } while (i<=j);
 if (l<j) subsortdata (x,l,j);
 if (i<r) subsortdata (x,i,r);
} /* subsortdata */
/*********************************************/
void sortdata (x,n)
 real *x;
 long n;
{
 subsortdata (x,0L,(long)n-1);
} /* sortdata */
/*********************************************/
void subsortdatai (x,index,l,r)
 real *x,*index;
 long l,r;
{
 long i=l,j=r;
 real v,w;

 v = x[(l+r)/2];
 do {
  while (x[i]<v) i++;
  while (x[j]>v) j--;
  if (i<=j) {
   w = x[i];
   x[i] = x[j];
   x[j] = w;
   w = index[i];
   index[i] = index[j];
   index[j] = w;
   i++;
   j--;
  };
 } while (i<=j);
 if (l<j) subsortdatai (x,index,l,j);
 if (i<r) subsortdatai (x,index,i,r);
} /* subsortdatai */
/*********************************************/
void sortdatai (x,index,n)
 real *x,*index;
 long n;
{
 subsortdatai (x,index,0L,(long)(n-1));
} /* sortdatai */
/*********************************************/
void subsortdata3 (x,l,r,y,z)
 real *x,*y,*z;
 long l,r;
{
 long i=l,j=r;
 real v,w;

 v = x[(l+r)/2];
 do {
  while (x[i]<v) i++;
  while (x[j]>v) j--;
  if (i<=j) {
   w = x[i]; x[i] = x[j]; x[j] = w;
   w = y[i]; y[i] = y[j]; y[j] = w;
   w = z[i]; z[i] = z[j]; z[j] = w;
   i++;
   j--;
  };
 } while (i<=j);
 if (l<j) subsortdata3 (x,l,j,y,z);
 if (i<r) subsortdata3 (x,i,r,y,z);
} /* subsortdata3 */
/*********************************************/
void sortdata3 (x,n,y,z)
 real *x,*y,*z;
 long n;
{
 subsortdata3 (x,0L,(long)(n-1),y,z);
} /* sortdata3 */
/*********************************************/
void subsortdatavm (x,A,d,l,r)
 vector x;
 matrix A;
 int d,l,r;
{
 int i=l,j=r;
 real v,w;
 vector wv;

 v = x[(l+r)/2];
 do {
  while (x[i]<v) i++;
  while (x[j]>v) j--;
  if (i<=j) {
                     /*  x[i]  <->  x[j]   */
   w = x[i];
   x[i] = x[j];
   x[j] = w;
                     /*  A[i]  <->  A[j]   */
   copy (wv,A[i],d);
   copy (A[i],A[j],d);
   copy (A[j],wv,d);

   i++;
   j--;
  };
 } while (i<=j);
 if (l<j) subsortdatavm (x,A,d,l,j);
 if (i<r) subsortdatavm (x,A,d,i,r);
} /* subsortdatavm */
/*********************************************/
void sortdatavm (x,A,d)
 vector x;
 matrix A;
 int d;
{
 subsortdatavm (x,A,d,0,d-1);
} /* sortdatavm */
/*********************************************/
/*********************************************/
void  minmax (x,dl,pxmin,pxmax)
 real *x,*pxmin,*pxmax;
 long dl;
 {
  long i;

  *pxmin = x[0];
  *pxmax = x[0];
  for(i=1;i<dl;i++){
   if (x[i] < *pxmin) *pxmin = x[i];
   if (x[i] > *pxmax) *pxmax = x[i];
  };
 } /* minmax */
/*******************************************/
void sfiltrdata (x,n)
 real *x;
 long n;
{
 real v = x[0], w;
 long i;

 for (i=1;i<n-1;i++) {
  w = (v + x[i] + x[i+1]) / 3;
  v = x[i];
  x[i] = w;
 };
} /* sfiltrdata */
/*******************************************/
void s2filtrdata (x,y,n)
 real *x,*y;
 long n;
{
 real v = y[0],
  x1,x2,x3,xs,yl,y2,y3,z1,z2,z3,a,b,w;
 long i;

 for (i=1;i<n-1;i++) {
  x1 = x [i-1];
  x2 = x [i  ];
  x3 = x [i+1];
  yl = v;
  y2 = y [i  ];
  y3 = y [i+1];
  xs = (x1 + x2 + x3) / 3;
  z1 = x1 - xs;
  z2 = x2 - xs;
  z3 = x3 - xs;
  a  = (z1 * yl + z2 * y2 + z3 * y3) / 
       (z1 * z1 + z2 * z2 + z3 * z3);
  b = (yl + y2 + y3) / 3;
  w = a * z2 + b;
  v = y[i];
  y[i] = w;
 };
} /* s2filtrdata */
/*******************************************/
void filtrdata (x,y,n,m)
 real *x,*y;
 long n,m;
{
 real *a, w=0, c = 0.4 * pow ((double)m,1.9);
 long i,j,k;
 static long ncalled = 0;

 if (debug) called ("filtrdata",&ncalled);

 allocdata (&a,(long)(m+1));
 for (i=0;i<=m;i++) a[i] = exp ((double)(-i*i/c));
 for (i= -m;i<=m;i++) w += a[labs(i)];
 for (i=0;i<=m;i++) a[i] /= w;

 if (debug) 
  for (i=0;i<=m;i++)
   (void)fprintf (stderr,"%G\n",a[i]);

 for (i=0;i<n;i++) {
  w = 0;
  for (j= -m;j<=m;j++) {
   k = i+j;
   if (k < 0  ) k = 0;
   if (k > n-1) k = n-1;
   w += a [labs(j)] * x[k];
  };
  y[i] = w;
 };
 free ((void*)a);
 if (debug) leave ("filtrdata");
} /* filtrdata */
/*******************************************/
void standardize (x,n)
 real *x;
 long n;
{
 real m=0,ms=0,msd,rmsd;
 long i;

 for (i=0;i<n;i++) {
  m  += x[i];
  ms += x[i] * x[i];
 }; 
 m   /= n;          /* mean                       */
 ms  /= n;          /* mean square                */
 msd  = ms - m*m;   /* mean square deviation      */
 rmsd = Sqrt (msd); /* root mean square deviation */

 for (i=0;i<n;i++) x[i] = (x[i]-m)/rmsd;

} /* standardize */
/*******************************************/
void astandardize (x,a,n)
 real *x;
 long *a,n;
{
 real m=0,ms=0,msd,rmsd;
 long i,j=0;

 for (i=0;i<n;i++) 
  if (a[i]) {
   j++;
   m  += x[i];
   ms += x[i] * x[i];
 };
 m   /= j;          /* mean                       */
 ms  /= j;          /* mean square                */
 msd  = ms - m*m;   /* mean square deviation      */
 rmsd = Sqrt (msd); /* root mean square deviation */

 for (i=0;i<n;i++)
  if (a[i]) x[i] = (x[i]-m)/rmsd;
  else      x[i] = 0;
} /* astandardize */
/*******************************************/
void autocor (x,y,n)
 real *x,*y;
 long n;
{
 long i,j;
 real w;

 for (i=0;i<n/2;i++) {
  w = 0;
  for (j=0; j < n-i; j++) w += x[j] * x[j+i];
  w /= n-i; 
  y[i] = w; 
 };
} /* autocor */ 
/*******************************************/
void accumdata (x,n)
 real *x;
 long n;
{
 long i;
 real w=0;

 for (i=0;i<n;i++) {
  w += x[i];
  x[i] = w;
 };
} /* accumdata */
/*******************************************/
void accumpdata (x,n,p)
 real *x,p;
 long n;
{
 long i;
 real w=0;

 for (i=0;i<n;i++) {
  w += pow ((double)x[i],(double)p);
  x[i] = w;
 };
} /* accumpdata */
/*******************************************/
/*******************************************/
real Log2 (wx) real wx; {return (Log(wx)/Log(2));}
/*******************************************/
void sqrtc (y,x)
 real x[2],y[2];
{
 real r  = Sqrt (Sqrt ((x[0]*x[0]+x[1]*x[1]))),
      fi = atan2 ((double)x[1],(double)x[0])/2;
 y[0] = r * Cos (fi);
 y[1] = r * Sin (fi);
}
/*******************************************/
void sqrc (y,x)
 real x[2],y[2];
{
 real w = x[0]*x[0]-x[1]*x[1];
 y[1] = 2 * x[0] * x[1];
 y[0] = w;
}
/*******************************************/
void rk6 (t,x,h,f)
/* local error = O(h^6) */
 real *t,*x,h,(*f)();
{
# define a1    0.25
# define b11   0.25
# define a2    0.25
# define b21   0.125
# define b22   0.125
# define a3    0.5
# define b31   0.0
# define b32  -0.5
# define b33   1.0
# define a4    0.75
# define b41   0.1875
# define b42   0.0
# define b43   0.0
# define b44   0.5625
# define a5    1.0
# define b51  -3.0/7.0
# define b52   2.0/7.0
# define b53  12.0/7.0
# define b54 -12.0/7.0
# define b55   8.0/7.0
# define cc   90.0
# define c1    7.0
# define c2    0.0
# define c3   32.0
# define c4   12.0
# define c5   32.0
# define c6    7.0
 
 real k1,k2,k3,k4,k5,k6;
 k1 = h * f (*t,     *x);
 k2 = h * f (*t+a1*h,*x+b11*k1);
 k3 = h * f (*t+a2*h,*x+b21*k1+b22*k2);
 k4 = h * f (*t+a3*h,*x+b31*k1+b32*k2+b33*k3);
 k5 = h * f (*t+a4*h,*x+b41*k1+b42*k2+b43*k3+b44*k4);
 k6 = h * f (*t+a5*h,*x+b51*k1+b52*k2+b53*k3+b54*k4+b55*k5);
 *x += (c1*k1+c2*k2+c3*k3+c4*k4+c5*k5+c6*k6) / cc;
 *t += h;

# undef a1
# undef b11
# undef a2
# undef b21
# undef b22
# undef a3
# undef b31
# undef b32
# undef b33
# undef a4
# undef b4
# undef b42
# undef b43
# undef b44
# undef a5
# undef b51
# undef b52
# undef b53
# undef b54
# undef b55
# undef cc
# undef c1
# undef c2
# undef c3
# undef c4
# undef c5
# undef c6
} /*  rk6 */
/*********************************************/
void vectprod (x,a,b,d)
 real *x,*a,*b;
 int d;
{
 if (d!=3) er ("dim <> 3 in vectprod");
 x[0] = a[1]*b[2] - a[2]*b[1];
 x[1] = a[2]*b[0] - a[0]*b[2];
 x[2] = a[0]*b[1] - a[1]*b[0];
} /* vectprod */
/*********************************************/
void perpen (a,b,x,d)
 real *a,*b,*x;
 int d;
{
 real v[DIM];
 real w = Abs (x[0]);
 int i,m=0;

 for (i=1;i<d;i++)
  if (Abs(x[i]) < w) {
   m = i;
   w = Abs (x[i]);
  };
 for (i=0;i<d;i++) v[i] = 0;
 v[m] = 1;
 vectprod (a,v,x,d);
 vectprod (b,a,x,d);
 normalize (a,d);
 normalize (b,d);
} /* perpen */
/*********************************************/
/*********************************************/
real lnf (x) /* log factorial */
 real x;
{
 real w = 0;

 while (x>1)  w += Log(x--);
 return (w);
} /* lnf */
/*********************************************/
real lnfs (x) /* log factorial ala Stirling */
 real x;
/* 
    n   error 
    1    0
    2    0.04
   10    0.07
 10^7    0.08
*/
{
 if (x<1) 
  return (0.0);
 else 
  return (x*Log(x) - x + 0.5*Log(x) + 1);
} /* lnfs */
/*********************************************/

# ifdef HIGH_PRECISION

/*********************************************/
long double ldfrac (x)
long double x;
{ return (x-floor((double)x));}
/*************************************/
long double ldsin (x)
long double x;
{
 long double result;
 int p;
 extern long double ldfrac();
 extern long double ldrsin();
 extern long double ldrcos();
 
 x = twoPi * ldfrac (x/twoPi);
 p = (int) (4 * x / Pi);

 switch (p) {
  case 0 : result =  ldrsin (x);        break;
  case 1 : result =  ldrcos (PiHalf-x); break;
  case 2 : result =  ldrcos (x-PiHalf); break;
  case 3 : result =  ldrsin (Pi-x);     break;
  case 4 : result = -ldrsin (x-Pi);     break;
  case 5 : result = -ldrcos (Pi3_2-x);  break;
  case 6 : result = -ldrcos (x-Pi3_2);  break;
  case 7 : result = -ldrsin (twoPi-x);  break;
 };
 return (result);
} /* ldsin */
/*************************************/
long double ldcos (x)
long double x;
{
 long double result;
 int p;
 extern long double ldfrac();
 extern long double ldrsin();
 extern long double ldrcos();
 
 x = twoPi * ldfrac (x/twoPi);
 p = (int) (4 * x / Pi);

 switch (p) {
  case 0: result =  ldrcos (x);        break;
  case 1: result =  ldrsin (PiHalf-x); break;
  case 2: result = -ldrsin (x-PiHalf); break;
  case 3: result = -ldrcos (Pi-x);     break;
  case 4: result = -ldrcos (x-Pi);     break;
  case 5: result = -ldrsin (Pi3_2-x);  break;
  case 6: result = ldrsin (x-Pi3_2);  break;
  case 7: result = ldrcos (twoPi-x);  break;
 };
 return (result);
} /* ldcos */
/*************************************/
long double ldrsin (x)
long double x;
{
 int n = 2;
 long double q = x * x,
             a = x,
             s = a;
 do {
  a *= q / n / (n+1); s -= a; n+= 2;
  a *= q / n / (n+1); s += a; n+= 2;
 } while (a > ldeps);
 return (s);
} /* ldrsin */
/*************************************/
long double ldrcos (x)
long double x;
{
 int n = 1;
 long double q = x * x,
             a = 1,
             s = a;
 do {
  a *= q / n / (n+1); s -= a; n+= 2;
  a *= q / n / (n+1); s += a; n+= 2;
 } while (a > ldeps);
 return (s);
} /* ldrcos */
/*************************************/
long double ldsqrt (x)
long double x;
{
 long double y = sqrt ((double)x);
 return ((y+x/y)/2);
} /* ldsqrt */
/*************************************/
long double ldSin (x)
long double x;
{
 long double result;
 int p;
 extern long double ldfrac();
 extern long double ldmsin();
 extern long double ldmcos();
 
 x = twoPi * ldfrac (x/twoPi);
 p = (int) (4 * x / Pi);

 switch (p) {
  case 0 : result =  ldmsin (x);        break;
  case 1 : result =  ldmcos (PiHalf-x); break;
  case 2 : result =  ldmcos (x-PiHalf); break;
  case 3 : result =  ldmsin (Pi-x);     break;
  case 4 : result = -ldmsin (x-Pi);     break;
  case 5 : result = -ldmcos (Pi3_2-x);  break;
  case 6 : result = -ldmcos (x-Pi3_2);  break;
  case 7 : result = -ldmsin (twoPi-x);  break;
 };
 return (result);
} /* ldSin */
/*************************************/
long double ldCos (x)
long double x;
{
 long double result;
 int p;
 extern long double ldfrac();
 extern long double ldmsin();
 extern long double ldmcos();
 
 x = twoPi * ldfrac (x/twoPi);
 p = (int) (4 * x / Pi);

 switch (p) {
  case 0: result = ldmcos (x);        break;
  case 1: result = ldmsin (PiHalf-x); break;
  case 2: result = ldmsin (x-PiHalf); break;
  case 3: result = ldmcos (Pi-x);     break;
  case 4: result = ldmcos (x-Pi);     break;
  case 5: result = ldmsin (Pi3_2-x);  break;
  case 6: result = ldmsin (x-Pi3_2);  break;
  case 7: result = ldmcos (twoPi-x);  break;
 };
 return (result);
} /* ldCos */
/*************************************/
long double ldmsin (v)
 long double v;
{ return (   0.0L 
   + v * (   1.0000000000000000000000000000014969422553L
   + v * ( - 3.0753090525658862328276038068746432165638E-28L
   + v * ( - 0.1666666666666666666666666444130624110775L
   + v * ( - 8.2183682211363006305699370999438974749279E-25L
   + v * (   0.0083333333333333333333515878642613724527L
   + v * ( - 2.6763582353725325354151118770490586227841E-22L
   + v * ( - 0.0001984126984126984099511885497321328819L
   + v * ( - 2.0539724813299525149331974120227134242916E-20L
   + v * (   2.7557319223987039973026373844162083339977E-6L
   + v * ( - 4.9027610011883610269670595138158626794292E-19L
   + v * ( - 2.5052108383828584168686412338554905798622E-8L
   + v * ( - 4.1181180080527276750007730252357619244739E-18L
   + v * ( + 1.6059044652799793873073251478754898600218E-10L
   + v * ( - 1.2477111281397993887853615749630408741498E-17L
   + v * ( - 7.6470184663500111891550489996709795684464E-13L
   + v * ( - 1.2562265321511996734510153144313468872043E-17L
   + v * (   2.8191756951445983281881220625103568515828E-15L
   + v * ( - 3.0872648822844969560074110458425104667095E-18L
   + v * ( - 7.5808594872384426843178059430192804235541E-18L
   ))))))))))))))))))));
} /* ldmsin */
/*************************************/
long double ldmcos (v)
 long double v;
{ return (   1.0L
   + v * (   3.8141589308706127892482895395392602961106E-30L
   + v * ( - 0.5000000000000000000000000007841124870749L
   + v * (   5.6811210203820346053029881907699596219625E-26L
   + v * (   0.0416666666666666666666645647021610480067L
   + v * (   4.6806066371539432478057434733023489784591E-23L
   + v * ( - 0.0013888888888888888895773634056693376707L
   + v * (   7.0960983155075070488138819611080350866462E-21L
   + v * (   0.0000248015873015872482611445421801843918L
   + v * (   3.0028974580766492097552903296198319207695E-19L
   + v * ( - 2.7557319224115001162681672537210947768027E-7L
   + v * (   4.2901640710174387334132098788191879710501E-18L
   + v * (   2.0876756876968156928088977580415949919368E-9L
   + v * (   2.2331975668036383786210402901152278144429E-17L
   + v * ( - 1.1470780485851844018990931907324617635166E-11L
   + v * (   4.1837997258345421644472503466560658425415E-17L
   + v * (   4.7757000391701367704939705078746211813607E-14L
   + v * (   2.4844033745203587751286030030690857241006E-17L
   + v * ( - 1.6743745529348078486393762777832279729211E-16L
   + v * (   3.1400948140589100279540916711707589022011E-18L
   ))))))))))))))))))));
} /* ldmcos */
/*************************************/
void ldwrite(x)
 long double x;
{
 int f = floor ((double)x);
 int n,i=0,im=35;

 if (x<0) {(void)printf ("-");x= -x;}
 else      (void)printf (" ");
 (void)printf ("%d.",f);
 x = x - f;

 while ((x > 0) && (i++ < im)) {
  x *= 10;
  n = (int) x;
  (void)printf ("%d",n);
  x -= n;
 };

 (void)printf ("\n");

} /* ldwrite */
/*************************************/
long double ldabs (x)
 long double x;
{
 if (x < 0) return (-x);
 else       return ( x);
} /* ldabs */
/*************************************/
long double ldlog (x)
 long double x;
{
 return ((long double)log((double)x));
} /* ldlog */
/*************************************/

# endif  /*  HIGH_PRECISION  */

/*************************************/
/*******************************************/
void rktest (to,yo,h,ea,eb,ec,f,p,d)
 real to;
 vector yo;
 real h,*ea,*eb,*ec;
 void (*f)();
 vector p;
 int d;

{
 vector y,yoo,dy;
 extern real norm();
 real r;
 static long ncalled = 0;

 if (debug) called ("rktest",&ncalled);

 grk (to  ,yo,y  , h,f,p,d);
 grk (to+h,y ,yoo,-h,f,p,d);
 minusvv (dy,yoo,yo,d);
/*
writevector ("yoo",yoo,d);
writevector ("yo ",yo ,d);
writevector ("dy ",dy ,d);
*/
*ea = norm (dy,d);

 rkr (to  ,yo,y  ,ec, h,f,p,d);
 rkr (to+h,y ,yoo,&r,-h,f,p,d);
 minusvv (dy,yoo,yo,d);
 *eb = norm (dy,d);
 if (debug) leave ("rktest");
} /* rktest */
/*************************************/
void rktesttab (to,yo,f,p,d)
 real to;
 vector yo;
 void (*f)();
 vector p;
 int d;
{
 real h1,h2,da1,da2,db1,db2,dc1,dc2,q = 1.2,ra,rb,rc;
 int i,im=28;

 (void)printf ("               grk <->            rkr <->             Richardson \n");
 (void)printf ("  h           d      r           d       r            d       r\n\n");

 h1 = 0.2;
 rktest (to,yo,h1,&da1,&db1,&dc1,f,p,d);
 
 for (i=0; i<im && da1>0 && db1>0 && dc1>0; i++) {
  h2  = h1;
  da2 = da1;
  db2 = db1;
  dc2 = dc1;

  h1 = h1 / q;  
  rktest (to,yo,h1,&da1,&db1,&dc1,f,p,d);

  if (da1>0 && db1>0 && dc1>0) {
   ra = Log (da1/da2) / Log (h1/h2);
   rb = Log (db1/db2) / Log (h1/h2);
   rc = Log (dc1/dc2) / Log (h1/h2);

   (void)printf (
   "%-8.3G  %-8.3G  %-8.3G  %-8.3G  %-8.3G  %-8.3G  %-8.3G\n",
     (double)h1,
     (double)da1,(double)ra,
     (double)db1,(double)rb,
     (double)dc1,(double)rc);
  };
 };
} /* rktesttab */
/*******************************************/
/*******************************************/
void orthonormalizen (D,e,n,d)
 matrix D;
 vector e;
 int n,d;
{
 real s;
 vector v;
 int j,k;

 if (debug) (void) fprintf (stderr,"orthonormalizen called\n");
 for (j=0;j<n;j++) {
  for (k=0;k<j;k++) {
   s = scalprod (D[j], D[k], d);
   timessv (v,s,D[k],d);
   minusvv (D[j],D[j],v,d);
  };
  e[j] = norm (D[j],d);
  normalize (D[j],d);
 };
 if (debug) (void) fprintf (stderr,"orthonormalizen O.K.\n");
/*
writevector ("e = ",e,n);
*/
} /* orthonormalizen */
/*********************************************/
real cosfi (a,b,d)
 vector a,b;
 int d;
{
 real A=0,B=0,AB=0;
 int i;

 for (i=0;i<d;i++) {
  A  += a[i]*a[i]; 
  B  += b[i]*b[i];
  AB += a[i]*b[i];
 };
 A = Sqrt (A);
 B = Sqrt (B);
 return (AB/A/B);
} /* cosfi */
/*********************************************/
void v2M (M,v,n,d)
 matrix M;
 vector v;
 int n,d;
{
 int i;
 
 for (i=0;i<n;i++) copy (M[i],v+d*(i+1),d);
} /* v2M */
/*********************************************/
void M2v (v,M,n,d)
 vector v;
 matrix M;
 int n,d;
{
 int i;
 
 for (i=0;i<n;i++) copy (v+d*(i+1),M[i],d);
} /* M2v */
/*********************************************/
void LE (v,le,F,p,T,TT,o,steps,nle,d)
 vector v,le,p;
 void (*F)(); 
 real T,TT;
 int o,steps,nle,d;
{
 real t = 0;
 vector e,s,x,y,xy,xx,yy,leo;
 int i, dim = d+nle*d, n=0;
 matrix D;

 if (dim > DIM) {
  (void) fprintf (stderr,
   "sorry, dim = %1d > maxdim = %1d\n", dim,DIM);
  exit (0);
 };

 for (i=0;i<nle;i++) s[i]=x[i]=y[i]=xx[i]=yy[i]=xy[i] = 0;
 for (i=d;i<DIM;i++) v[i] = 0;
 for (i=d;i<dim;i++) v[i] = myrand();

 v2M (D,v,nle,d);
 orthonormalizen (D,e,nle,d);
 M2v (v,D,nle,d);

 seth0 (1E-7);
 integdt (&t,TT,v,F,p,d);
/*------------------------------------------------*/
 while (t < T + TT) {

  for (i=0;i<steps;i++) integ1h (&t,v,F,p,dim);

  v2M (D,v,nle,d);
  orthonormalizen (D,e,nle,d);
  M2v (v,D,nle,d);
  for (i=0;i<nle;i++) {
    s [i] += Log (e[i]);
    x [i] += t;
    y [i] += s[i];
    xx[i] += t*t;
    yy[i] += s[i]*s[i];
    xy[i] += t*s[i];
  };
  n++;

  if (o==1 && n>1) {
   (void) printf ("%G ",t);
   for (i=0;i<nle;i++) {
    le [i] = (xy[i]/n-x[i]/n*y[i]/n) / (xx[i]/n-x[i]/n*x[i]/n);   
    leo[i] = s [i] / (t-TT);
    (void) printf ("%G %G ",le[i],leo[i]);
   };
   (void) printf ("\n");
  };

  if (o==2) {
   (void)printf("%G ",t);
   for (i=0;i<nle;i++)
    (void)printf("%G ",s[i]);
   (void)printf("\n");
  };

  if (o==3) {
   (void)printf("%G ",t);
   for (i=0;i<dim;i++)
    (void)printf("%G ",v[i]);
   for (i=0;i<nle;i++)
    (void)printf("%G ",s[i]);
   (void)printf("\n");
  };

 }; /* t */
/*------------------------------------------------*/
  for (i=0;i<nle;i++) {
   le [i] = (xy[i]/n-x[i]/n*y[i]/n) / (xx[i]/n-x[i]/n*x[i]/n);   
   leo[i] = s [i] / (t-TT);
  };
} /* LE */
/*********************************************/
void LEd (x,le,F,p,iT,iTT,o,steps,nle,d)
 vector x,le,p;
 int (*F)(); 
 int  iT,iTT;
 int o,steps,nle,d;
{
 int it = 0;
 vector e,s;
 int i, dim = d+nle*d;
 matrix D;

 if (debug) (void) fprintf (stderr,"LEd called\n");

 if (dim > DIM) {
  (void) fprintf (stderr,
   "sorry, dim = %1d > maxdim = %1d\n", dim,DIM);
  exit (0);
 };

 for (i=0;i<nle;i++) s[i] = 0;
 for (i=d;i<DIM;i++) x[i] = 0;
 for (i=d;i<dim;i++) x[i] = myrand();

 v2M (D,x,nle,d);
 orthonormalizen (D,e,nle,d);
 M2v (x,D,nle,d);

 if (debug){
  (void) fprintf(stderr,"iTT=%d\n",iTT);
  writevector ("x = ",x,d);
  writevector ("p = ",p,d);
  (void) fprintf(stderr,"d =%d\n",d );
 }; 
for (it=0;it<iTT;it++) F(x,p,d); 
/*------------------------------------------------*/
 for (it=0;it<iT;it++) {
  for (i=0;i<steps;i++) F(x,p,dim); 
  v2M (D,x,nle,d);
  orthonormalizen (D,e,nle,d);
  M2v (x,D,nle,d);

  for (i=0;i<nle;i++) s[i] += Log (e[i]);

 if (o==1) {
   (void)printf("%d ",it);
   for (i=0;i<nle;i++)
    (void)printf("%G ",s[i]);
   (void)printf("\n");
  };

  if (o==2) {
   (void)printf("%d ",it);
   for (i=0;i<dim;i++)
    (void)printf("%G ",x[i]);
   for (i=0;i<nle;i++)
    (void)printf("%G ",s[i]);
   (void)printf("\n");
  };

 }; /* it */
/*------------------------------------------------*/
 for (i=0;i<nle;i++) le[i] = s [i] / it;
 if (debug) (void) fprintf (stderr,"LEd O.K.\n");
} /* LEd */
/*********************************************/
/*********************************************/
void binprintshort (b)
short b;
{
 int i;

 for (i=0;i<16;i++) {
  (void) printf ("%c",'0'+!!(b << i & 0x8000));
  if (i%8 == 7) (void) printf (" ");
 };
} /* binprint */
/**************************************/
void binprintdouble (x)
 double x;
{
 int i;
 short* ps;

 for (i=0;i<4;i++) {
  ps = (short*) &x;
  ps = ps + i;
  binprintshort (*ps);
 };
 (void) printf ("\n");
} /* binprintdouble */
/**************************************/
/**************************************/
int ilog2 (x)
 double x;
{
 return (
  (int) (* (short*) &x  >> 4   &   0x07FF) - 0x03FF
 );
} /* ilog2 */
/**************************************/
# ifdef HIGH_PRECISION
ildlog2 (x)
 long double x;
{
 return (
  (int) (* (short*) &x         &   0x7FFF) - 0x3FFF
 );
} /* ildlog2 */
# endif
/************************************************/
/************************************************/
long two2n (n)
 long n;
{
 long nn,nnn;
 extern long Roundl();
 static long ncalled = 0;

 if (debug) called ("two2n",&ncalled);
 nn  = Roundl (Log2 ((real)n));
 nnn = Roundl ((real)pow (2.0,(double)nn));
 if (n < nnn) nn--;
 n   = Roundl ((real)pow (2.0,(double)nn));
 if (debug) leave ("two2n");
 return (n);
} /* two2n */
/************************************************/
long bitinv (n,size,columns)
 long n,size,columns;
{
 long r,i,b;

 r = size / 2;
 b = 0;
 for (i=0;i<columns;i++) {
  if (n & 1L) b += r;
  n /= 2;
  r /= 2;
 };
 return (b);
} /* bitinv */
/************************************************/
void reorder(x,size,columns)
 real *x;
 long size,columns;
{
 long i,b;
 real w;
 extern long bitinv ();

 for (i=0;i<size;i++) {
  b = bitinv (i,size,columns);
  if (b>i) {
   w = x[i];
   x[i] = x[b];
   x[b] = w;
  };
 };
} /* reorder */
/************************************************/
void TrigTable (csn,size)
 real *csn;
 long size;
{
 long i;
 real angle, omega;

   angle = 0;
   omega = 2*Pi/size;
   for (i=0;i<=size/4;i++) {
     csn[i] = Cos (angle);
     angle += omega;
   };
} /* TrigTable */
/************************************************/
void fht (x,size)  /* 128 k ... 4.75 s */
 real *x;
 long size;
{
 long c,columns,g,groups,b,n,n2,n4,org,i1,i2,i3,i4,i;
 real cm,sm,z1,z2,w1,w2,w3,w4,yl,y2,scale;
 real *csn;

 allocdata (&csn,(long)(size/4+1));
 columns = Round (Log2 ((real)size));
 reorder (x,size,columns);
 TrigTable (csn,size);
 
  groups = size;
  for (c=1;c<=columns;c++) {
    groups /= 2;
    n = size / groups;
    n2 = n / 2;
    n4 = n / 4;
    for (g = 0; g < groups; g++) {
      org = g * n;
      yl = x[org] + x[org + n2];
      y2 = x[org] - x[org + n2];
      x[org] = yl;
      x[org + n2] = y2;
      for (b = 1; b <= n4; b++) {
	i1 = org + b;
	i2 = i1 + n2;
	i3 = org + n - b;
	i4 = i3 - n2;
	cm = csn[b * groups];
	sm = csn[size / 4 - b * groups];
	z1 = cm * x[i2] + sm * x[i3];
	z2 = cm * x[i3] - sm * x[i2];
	w1 = x[i1] + z1;
	w2 = x[i1] - z1;
	w3 = x[i4] + z2;
	w4 = x[i4] - z2;
	x[i1] = w1;
	x[i2] = w2;
	x[i3] = w3;
	x[i4] = w4;
      }  /* of butterfly */
    }  /* of group     */
  }  /* of column    */
  scale = Sqrt(size);
  for(i=0;i<size;i++) x[i] /= scale;
  free ((void*)csn);
}  /* fht */
/************************************************/
void MakeSpectrum (spectrum,x,size)
 real *spectrum,*x;
 long size;
{
 long i;

  spectrum[0] = x[0]*x[0];
  for (i=1;i<=size/2;i++)
   spectrum [i] = x[i]*x[i] + x[size-i]*x[size-i];
  i = size / 2;
  spectrum[i] = spectrum[i] / 2;

  for (i = 0; i <=  size / 2; i++)
   spectrum [i] /= size;
} /* MakeSpectrum */
/************************************************/
/************************************************/
void lookline (T,mgn,pos,i,d)
 matrix T;
 vector mgn;
 int pos[DIM], i, d;
{
 int j;

 if (i < d-1) {
  mgn[i] = Abs (T[i][i+1]);
  pos[i] = i+1;
  for (j=i+2;j<d;j++)
   if ( Abs (T[i][j]) > mgn[i] ) {
    mgn[i] = Abs (T[i][j]);
    pos[i] = j;
   };
 };
} /* lookline */
/***********************************/
void checkline (T,mgn,pos,i,p,q)
 matrix T;
 vector mgn;
 int pos[DIM], i, p, q;
{
 if ( Abs (T[i][p]) > mgn[i] ) {
  mgn[i] = Abs (T[i][p]);
  pos[i] = p;
 };
 if ( Abs (T[i][q]) > mgn[i] ) {
  mgn[i] = Abs (T[i][q]);
  pos[i] = q;
 };
} /* checkline */
/***********************************/
void firstlook (T,mgn,pos,d)
 matrix T;
 vector mgn;
 int pos[DIM], d;
{
 int i;

 for (i=0;i<d-1;i++)
  lookline (T,mgn,pos,i,d);
} /* firstlook */
/***********************************/
void look (T,mgn,pos,p,q,nar,d)
 matrix T;
 vector mgn;
 int pos[DIM], *p, *q, *nar, d;
{
 real w = 0, wT = Abs (T[0][0]);
 int i;

 for (i=0;i<d-1;i++)
  if (mgn[i] > w) {
   w  = mgn [i];
   *p = i;
   *q = pos[i];
  };

 for (i=1;i<d;i++)
  if (Abs (T[i][i]) > wT) wT = Abs (T[i][i]);

 *nar = w / wT < EPS;
 if (debug) (void) fprintf (stderr,"w = %G\n",(double) w);
} /* look */
/***********************************/
void diagiter (T, R, mgn, pos, nar, pp, pq, d)
 matrix T,R;
 vector mgn;
 int pos[DIM], *nar, *pp, *pq, d; 
{
 matrix Rt,RT,RTRt;
 real lambda,mi,ni,c,cc,s,ss,cs,w1,w2;
 int j, p = *pp, q = *pq;
 
 if (debug) {
  (void) fprintf (stderr,"------------------------\n");
  fwritematrix (stderr,"R = ",R,d,d);
  fwritematrix (stderr,"T = ",T,d,d);
  (void) fprintf (stderr,"p = %d  q = %d \n",p,q);
  fwritevector (stderr,"mgn = ",mgn,d-1);
  for (j=0;j<d-1;j++) (void) fprintf (stderr,"%10d ",pos[j]);
  (void) fprintf (stderr,"\n\n\n");
 };

 lambda = -T[p][q];
 mi = (T[p][p] - T[q][q]) / 2;
 ni = Sqrt (lambda*lambda+mi*mi);
 c  = Sqrt ( (Abs(mi) / ni + 1) / 2 );
 s  = lambda / 2 / ni / c;
 if (mi < 0) s = -s;
 cc = c * c;
 ss = s * s;
 cs = c * s;
 for (j=0;j<d;j++)
  if ( j != p && j != q ) {
   w1 = T [j] [p] * c - T [j] [q] * s;
   w2 = T [j] [p] * s + T [j] [q] * c;
   T [p] [j] = w1;
   T [q] [j] = w2;
   T [j] [p] = w1;
   T [j] [q] = w2;
  };

 w1 = T [p][p]*cc + T [q][q]*ss - 2 * T [p][q]*cs;
 w2 = T [p][p]*ss + T [q][q]*cc + 2 * T [p][q]*cs;
 T[p][p] = w1;
 T[q][q] = w2;

 T [p] [q] = 0;
 T [q] [p] = 0;

 for (j=0;j<d;j++) {
  w1 = R [j] [p] * c - R [j] [q] * s;
  w2 = R [j] [p] * s + R [j] [q] * c;
  R [j] [p] = w1;
  R [j] [q] = w2;
 };

 for (j=0;j<d-1;j++)
  if (j==p || j==q || pos[j]==p || pos[j]==q)
   lookline (T,mgn,pos,j,d);
  else 
   checkline (T,mgn,pos,j,p,q);
 look (T,mgn,pos,pp,pq,nar,d);

 if (debug) {
  transpose (Rt,R,d);
  timesmm (RT,R,T,d,d,d);
  timesmm (RTRt,RT,Rt,d,d,d);
  fwritematrix (stderr,"R     = ", R   ,d,d);
  fwritematrix (stderr,"T     = ", T   ,d,d);
  fwritematrix (stderr,"RTRt  = ", RTRt,d,d);
  (void) fprintf (stderr,"p = %d  q = %d \n",*pp,*pq);
  (void) fprintf (stderr,"------------------------\n");
 };

} /* diagiter */
/***********************************/
void diagonalize (A,Q,s,d)
 matrix A,Q;
 vector s;
 int d;
{
 int pos[DIM], p, q, narrow;
 vector mgn;
 matrix T, R;

/*  A must be a symmetric matrix       */
/*  1 -> R -> Qt                       */
/*  A -> T -> D -> s                   */
/*  rows of Q are eigenvectors of A    */
/*  elements of s are eigenvalues of A */
/*  A = Qt.D.Q                         */
/*  50x50 in 4 seconds                 */

 make1matrix (R,d);
 copymatrix (T,A,d,d);
 firstlook (T,mgn,pos,d);
 look (T,mgn,pos,&p,&q,&narrow,d);
 while (!narrow)
  diagiter (T,R, mgn, pos, &narrow, &p, &q, d);

 transpose (Q,R,d);
 extractdiag (s,T,d);

 sortdatavm (s,Q,d);
 revdata (s,(long)d);
 revmatrix (Q,d);

 sqrtvector (s,d);
 sumnormvector (s,d);
} /* diagonalize */
/***********************************/
/***********************************/
void lsm (x,y,n,c,d,e,r,L)
 real *x,*y; /* input data   */
 long n;
 vector c;   /* coefficients */
 real *d;    /* deviations   */ 
 real *e;    /* rmsd         */
 real *r;    /* correlation  */
 int L;
{
 vector P;
 matrix R;
 long i;
 int j,k,m;
 real w,v;
 extern real corcoef ();

 for (k=0;k<L;k++) {
  w = 0;
  for (i=0;i<n;i++) {
   v = y[i];
   for (m=0;m<k;m++) v *= x[i];
   w += v;
  };
  P[k] = w / n;
 };

 for (j=0;j<2*L-1;j++) {
  w = 0;
  for (i=0;i<n;i++) {
   v = 1;
   for (m=0;m<j;m++) v *= x[i];
   w += v;
  };
  for (k=0;k<=j;k++)
   if (k<L && (j-k)<L)
    R[k][j-k] = w / n;
 };
 SolveLin (R,c,P,L);
/*  invmat (R,L); timesmv (c,R,P,L,L); */

 *e = 0;
 for (i=0;i<n;i++) {
  w = 0;
  for (k=0;k<L;k++) {
   v = c[k];
   for (m=0;m<k;m++) v *= x[i];
   w += v;
  };
  d[i] = y[i] - w;
  *e += d[i] * d[i];
 };
 *e = Sqrt ((double)*e);
 *r = corcoef (x,y,n);
} /* lsm */
/************************************************/
real corcoef (x,y,n)
 real *x,*y;
 long n;
{
 real w;
 long i;

 standardize (x,n);
 standardize (y,n);

 w = 0;
 for (i=0;i<n;i++) w += x[i] * y[i];

 return (w/n);
} /* corcoef */
/************************************************/
real Nad (a,b)
 long a,b;
{
 real r = 1;

 if (a<0 || b<0 || b>a) return ((real)0);
 if (2*b > a) b = a-b;
 while (b) r *= (a--)/(real)(b--);
 return (r);
} /* Nad */
/**********************************************/
real Bezier1 (t,a,N)
 real t,*a;
 long N;
{
 long i;
 real s;

/* here N is the number if input points */

 if (N==0) er ("Bezier curve from 0 points ?");
 if (N==1) return (a[0]);

 N--;
/* here N is the index of the last input point */

 if (t==0) return (a[0]);
 if (t==1) return (a[N]);

 s = a[0] * pow (1-t,(double)N) +
     a[N] * pow (  t,(double)N);

 for (i=1;i<N;i++)
  s += Nad (N,i) * a[i] * pow (  t,(double)   i ) * 
                          pow (1-t,(double)(N-i));
 return (s);
} /* Bezier1 */
/**********************************************/ 
/**********************************************/
void cco1 (x1,p,yl,v1,J,d)
 vector x1,p,yl;
 real v1;
 matrix J;
 int d;
{
 (void) fprintf (stderr,"---------cco1---------------\n");
 fwritevector (stderr,"x1 = ",x1,d);
 fwritevector (stderr,"p  = ",p ,d);
 fwritevector (stderr,"yl = ",yl,d);
 (void) fprintf (stderr,"v1  = %G\n",v1 );
 fwritematrix (stderr,"J  = ",J,d,d);
 (void) fprintf (stderr,"----------------------------\n");
} /* cco1 */
/*******************************************/
void cco2 (J,dx,d)
 matrix J;
 vector dx;
 int d;
{
 (void) fprintf (stderr,"---------cco2---------------\n");
 fwritematrix (stderr,"Jinv = ",J,d,d);
 fwritevector (stderr,"dx = ",dx,d);
 (void) fprintf (stderr,"----------------------------\n");
} /* cco2 */
/*******************************************/
void cco3 (eps1,eps2,v1,v2,p,x1,x2,dx,y2,n,N,m,M,s,d)
 real eps1,eps2,v1,v2;
 vector p,x1,x2,dx,y2;
 int n,N,m,M,s,d;
{
 (void) fprintf (stderr,"---------cco3---------------\n");
 (void) fprintf (stderr,"\n error: curvecorrector %d not converging \n",s);
 (void) fprintf (stderr,"d    = %d\n",d);
 (void) fprintf (stderr,"eps1 = %G\n",eps1);
 (void) fprintf (stderr,"eps2 = %G\n",eps2);
 (void) fprintf (stderr,"v1   = %G\n",v1 );
 (void) fprintf (stderr,"v2   = %G\n",v2 );
 fwritevector (stderr,"p  = ",p ,6);
 fwritevector (stderr,"x1 = ",x1,d);
 fwritevector (stderr,"x2 = ",x2,d);
 fwritevector (stderr,"dx = ",dx,d);
 fwritevector (stderr,"y2 = ",y2,d);
 (void) fprintf (stderr,"n   = %d\n",n  );
 (void) fprintf (stderr,"N   = %d\n",N  );
 (void) fprintf (stderr,"m   = %d\n",m  );
 (void) fprintf (stderr,"M   = %d\n",M  );
 exit (1);
} /* cco3 */
/**********************************************/
void cco4 (x0,dx,p,d)
 vector x0,dx,p;
 int d;
{
 (void) fprintf (stderr,"---------cco4---------------\n");
 fwritevector (stderr,"x0 = ",x0,d);
 fwritevector (stderr,"dx = ",dx,d);
 fwritevector (stderr,"p  = ",p ,d);
 exit (-1);
} /* cco4 */
/**********************************************/
void cco5 (x0,t,p,d)
 vector x0,t,p;
 int d;
{
 (void) fprintf (stderr,"---------cco5---------------\n");
 (void) fprintf (stderr,"initial curvecorrector in curve not converging\n");
 (void) fprintf (stderr,"probably bad start point x \n");
 (void) fprintf (stderr,"or start direction t\n");
 fwritevector (stderr,"x0 = ",x0,d);
 fwritevector (stderr,"t  = ",t ,d);
 fwritevector (stderr,"p  = ",p ,d);
 (void) fprintf (stderr,"dim = %d \n",d);
 exit (-1);
} /* cco5 */
/**********************************************/
void cco6 (x,x1,x2,d)
 vector x,x1,x2;
 int d;
{
 (void) fprintf (stderr,"---------cco6---------------\n");
 (void) fprintf (stderr,"error: start point out of range \n");
 fwritevector (stderr,"x  = ",x ,d);
 fwritevector (stderr,"x1 = ",x1,d);
 fwritevector (stderr,"x2 = ",x2,d);
 (void) fprintf (stderr,"dim = %d \n",d);
 exit (-1);
} /* cco6 */
/**********************************************/
void cco7 (x,x1,x2,d)
 vector x,x1,x2;
 int d;
{
 (void) fprintf (stderr,"---------cco7---------------\n");
 (void) fprintf (stderr,"error: start point after initial correction out of range \n");
 fwritevector (stderr,"x  = ",x ,d);
 fwritevector (stderr,"x1 = ",x1,d);
 fwritevector (stderr,"x2 = ",x2,d);
 (void) fprintf (stderr,"dim = %d \n",d);
 exit (-1);
} /* cco7 */
/**********************************************/
int curvecorrector (x0,t,f,p,J,d)
 vector x0,t,p;
 int d;
 void (*f)();
 matrix J;
{
 int n,N=10,m=0,M=10;
 real eps1 = 1E-6, eps2 = 1E-5, v1,v2,tim=0;
 vector x,x1,x2,dx,yl,y2,g;
 matrix Jinv;

 if (debug) writevector ("before curvecorrector x0 = \n",x0,d);

 copy (x1,x0,d);
 do {

  copy (x,x1,d);
  f (tim,x,p, yl,g,J,d);
  yl [d-1] = scalprod (x1,t,d) - scalprod (x0,t,d);
  v1 = norm (yl,d);
  copy (J[d-1],t,d);

  if (debug) cco1 (x1,p,yl,v1,J,d);

  SolveLin (J,dx,yl,d);
/*  copymatrix (Jinv,J,d,d); invmat (Jinv,d); timesmv (dx,Jinv,yl,d,d); */

  if (debug) cco2 (Jinv,dx,d);

  n=0;
  do {
   minusvv (x2,x1,dx,d);

   copy (x,x2,d);
   f (tim,x,p, y2,g,J,d);
   y2 [d-1] = scalprod (x2,t,d) - scalprod (x0,t,d);
   v2 = norm (y2,d);
   timessv (dx,0.5,dx,d);
   n++;
  } while ( v2>v1 && v2>eps1 && n<N );

  if (n==N) return (-1);
  copy (x1,x2,d);

  m++;
 } while (v2 > eps2 && m<M);

 if (m==M) return (-1);
 copy (x0,x1,d);
 if (debug) writevector ("after curvecorrector x0 = \n",x0,d);
 return (m);
/*

x1 = x0
   y1 = f(x1)
   dx = Jinv . y1
      x2 = x1 - dx
      y2 = f(x2)
      dx = dx / 2
      while (v2 > v1) & (v2 > eps1) & (n < N)
   x1 = x2
   while (v2 > eps2) & (m < M)
x0 - x1

*/
} /* curvecorrector */
/**********************************************/
void curve (x,x1,x2,t,noutmax,h,hmin,hmax,f,fout,p,d)
 vector x,x1,x2,t,p;
 int noutmax,d;
 void (*f)(),(*fout)();
 real h,hmin,hmax;
{
 int isin,n,N=10,ncor,nout=0,niter=0,nitermax=10*noutmax;
 vector x0,dx,xprev,t0;
 matrix J;

 if (!in(x,x1,x2,d)) cco6 (x,x1,x2,d);
 copy (xprev,x,d);
 ncor = curvecorrector (x,t,f,p,J,d);     /* initial correction */
 if (ncor <0) cco5 (x,t,p,d);
 if (!in(x,x1,x2,d)) cco7 (x,x1,x2,d);

 do {

  if(niter==0 || distance(x,xprev,d) > hmin) {
   fout (x,p,J,f,d);
   nout++;
   copy (xprev,x,d);
  };                                    /* output       */

  copy (x0,x,d);
  copy (t0,t,d);
  outer (t,J,d); 
  if (scalprod(t,t0,d)<0) timessv (t,-1.0,t,d);
  normalize (t,d);
  timessv (dx,h,t,d);

  n=0;
  do {
   plusvv (x,x0,dx,d);                   /* x = x0 + dx  */
   timessv (dx,0.5,dx,d);
   isin = in(x,x1,x2,d);
   if (isin) ncor = curvecorrector (x,t,f,p,J,d);
   if (ncor>0 && ncor < 2) h*= 2;
   if (          ncor > 2) h/= 2;
   if (h > hmax) h = hmax;
   isin = isin && in(x,x1,x2,d);
  } while (isin && ncor<0 && n++<N);
  if (ncor<0) cco4 (x0,dx,p,d);

 } while (isin && niter++<nitermax && nout<noutmax);
 if (debug) {
  fwritevector (stderr,"x  = ",x ,d);
  fwritevector (stderr,"x1 = ",x1,d);
  fwritevector (stderr,"x2 = ",x2,d);
  fwritevector (stderr,"t  = ",t ,d);
  (void) fprintf (stderr,"isin     = %d\n",isin);
  (void) fprintf (stderr,"niter    = %d\n",niter);
  (void) fprintf (stderr,"nitermax = %d\n",nitermax);
  (void) fprintf (stderr,"nout     = %d\n",nout);
  (void) fprintf (stderr,"noutmax  = %d\n",noutmax);
 };
/*

curvecorrector (x,t,J)
   output
   x0 = x
   t0 = t
   t  = outer(J)
   dx = h t
      x  = x0 + dx
      dx = dx / 2
      isin = in (x)
      if (isin) curvecorrector (x,t,J)
      h = 
      isin = isin & in (x)
      while (isin) & (ncor < 0) & (n++ < N)
   while (isin) & (niter++ < nitermax) & (nout < noutmax)

*/
} /* curve */
/*******************************************/
/*******************************************/
void verbq_conti (t,eig)
 int *t;
 vector eig;
{
 real r1 = eig[0],
      i1 = eig[1],
      r2 = eig[2];
 
 if (i1 != 0) {
  if (r1 < 0) *t = 0;           /* SF */
  else        *t = 1;           /* UF */
 } else {
  if      (r1 < 0 && r2 < 0) *t = 2;  /* SN */
  else if (r1 > 0 && r2 > 0) *t = 3;  /* UN */
  else                       *t = 4;  /* S  */
 };
} /* verbq_conti */
/*******************************************/
void verbq_discr (t,eig)
 int *t;
 vector eig;
{
 real r1 = fabs(eig[0]),
      i1 =      eig[1],
      r2 = fabs(eig[2]);
 
 if (i1 != 0) {
  if (r1 < 1) *t = 0;           /* SF */
  else        *t = 1;           /* UF */
 } else {
  if      (r1 < 1 && r2 < 1) *t = 2;  /* SN */
  else if (r1 > 1 && r2 > 1) *t = 3;  /* UN */
  else                       *t = 4;  /* S  */
 };
} /* verbq_discr */
/*******************************************/
real defint (f,a,b,p,n,m)
 real (*f)(),a,b;
 vector p;
 int n, /* number of divisions  */
   m;   /* method: 1 = trapezoid; global error = O(h^2)
                   2 = Simpson                       4
                   3 = cubic                         4
                   4 = bi-quadratic                  6  */
{
 real
  h = (b-a)/n/m,
  s = f(a,p),
  x = a + h;
 int i;

 for (i=1;i<n;i++) {
  switch (m) {
   case 1: s += 2       * f(x,p); x += h; break;
   case 2: s += 4       * f(x,p); x += h;
           s += 2       * f(x,p); x += h; break;
   case 3: s += 3       * f(x,p); x += h;
           s += 3       * f(x,p); x += h;
           s += 2       * f(x,p); x += h; break;
   case 4: s += 64.0/14 * f(x,p); x += h;
           s += 24.0/14 * f(x,p); x += h;
           s += 64.0/14 * f(x,p); x += h;
           s += 2       * f(x,p); x += h; break;
  };
 };
 switch (m) {
  case 2: s += 4       * f(x,p);         break;
  case 3: s += 3       * f(x,p); x += h;
          s += 3       * f(x,p);         break;
  case 4: s += 64.0/14 * f(x,p); x += h;
          s += 24.0/14 * f(x,p); x += h;
          s += 64.0/14 * f(x,p);         break;
 };
 s += f(b,p);
 switch (m) {
  case 1: s *=  1.0/2  * h; break;
  case 2: s *=  1.0/3  * h; break;
  case 3: s *=  3.0/8  * h; break;
  case 4: s *= 14.0/45 * h; break; 
  default: er("illegal def int method");
 };
 return (s);
} /* defint */
/******************************/
/*
real f (x) real x; { return (1/x);}
real F (a,b) real a,b; { return (log(b/a));}
*/
/******************************/
void definttest (f,F)
 real (*f)(), (*F)();
{
 real a=2.48,b=4.31,d,dd,r;
 int n,n1=1,n2=5000,q=2,m;
 vector p;

 for (m=1;m<5;m++) {
  dd = defint (f,a,b,p,n1,m) - F(a,b);
  for (n=n1*q;n<n2;n*=q) {
   d  = defint (f,a,b,p,n,m) - F(a,b);
   r  = log(fabs(dd/d)) / log ((double)q);
   dd = d;
   (void) printf ("%6d %10.3G %10.3f\n",n,d,r);
  };
  (void) printf ("\n");
 };
} /* definttest */
/***********************************************/
void findcycle (array,size,i1,i2,map,pars,dim)
 vectors array;
 int size,*i1,*i2,dim;
 void (*map)();
 vector pars;
{
 int per=0,head=0,i=0;

 while (head++, per==0 && head<size) {
  copy (array[head],array[head-1],dim);
  map(array[head],pars,dim);
  i=head;
  while (per==0 && i>0)
   if (i--, adistance(array[head],array[i],dim)<1e-10) per = head-i;
 };
 *i1 = i;
 *i2 = head-1;
} /* findcycle */
/***********************************************/
void readparams (p,s,d)
 vector p;
 char *s;
 int d;
{
 int i;
 FILE *f;

 ppopenr (&f,s);
 for (i=0;i<d;i++) {
  if (1 != fscanf(f,"%lf%*[^\n]",p+i)) {
   (void) fprintf (stderr,"error reading parameter #%d from file %s\n",i,s);
   exit (1);
  };
 };
 (void)fclose (f);
 if (debug) for (i=0;i<d;i++) (void)fprintf (stderr,"p[%d] = %g\n",i,p[i]);
} /* readparams */
/***************************************/
void dyn_type_disc_3 (ae,e,J)
 vector ae,e;
 matrix J;
/* input:  3x3 matrix J 
   output: e  = vector of 3 eigenvalues 
           ae = 3 Abs eigenvalues + 1 dynamical type
*/
{
 int a,b,c;

 eigenvalues3 (e,J);

 ae[0] = Sqrt(e[0]*e[0]+e[1]*e[1]); /* Abs Lambda1 */
 ae[0] = Sqrt(e[2]*e[2]+e[3]*e[3]); /* Abs Lambda1 */
 ae[0] = Sqrt(e[4]*e[4]+e[5]*e[5]); /* Abs Lambda1 */
/*
 ae[0] = hypot (e[0],e[1]); 
 ae[1] = hypot (e[2],e[3]);
 ae[2] = hypot (e[4],e[5]);
*/
 a = ae[0] > 1;
 b = ae[1] > 1;
 c = ae[2] > 1;

 ae[3] = (real) (a + b + c);

 if (e[1] != 0  ||  e[3] != 0  ||  e[5] !=0) ae[3] += 0.5;
/*
ae[3] = 0       SSS node
        0.5         focus
        1       SSU
        1.5
        2       SUU
        2.5
        3       UUU
        3.5
*/
} /* dyn_type_disc_3 */
/***********************************************/
/***********************************************/
void printPSprolog ()
{
 (void) printf ("\
%%!\n\
%%%%BoundingBox: 56 255 511 710\n\
gsave\n\
/inch { 72 mul } def\n\
/mm   { 25.4 div inch } def\n\n\
/YourX0       20 mm def\n\
/YourY0       60 mm def\n\
/YourScaleX  170 mm def\n\
/YourScaleY  170 mm def\n\
/YourAngle     0    def\n\n\
/centerx YourScaleX 2 div YourX0 add def\n\
/centery YourScaleY 2 div YourY0 add def\n\n\
/s  YourScaleX YourScaleY add \n\
       2 div  def \n\
/s0 180 mm     def\n\n\
/Times-Roman findfont  \n\
16 s0 div scalefont setfont\n\n");

 (void) printf ("\
/lw  0.2 s div def %% linewidth 0.2 points = 0.2*25.4/72 mm = 0.071 mm \n\
/r   0.1 s div def \n\
/r2  r  2 mul  def %% point radius 0.2 points \n\
/r4  r  4 mul  def \n\
/r8  r  8 mul  def \n\
/r16 r 16 mul  def %% circle (SN,UN and SL) radius 1.6 points \n\
/r32 r 32 mul  def \n\
/r64 r 64 mul  def \n\n\
/d  0.5 s div def %% dash length \n\
/d2 d 2 mul    def \n\
/d4 d 4 mul    def \n\
/d8 d 8 mul    def \n\
 centerx     centery     translate\n\
 YourAngle rotate \n\
 centerx neg centery neg translate\n\n\
 YourX0 YourY0 translate           \n\
 YourScaleX YourScaleY scale       \n\
 lw setlinewidth            \n\n\
/P  { %% POINT                      \n\
     r2 0 360 arc fill } bind def   \n\
/SN  {  %%  stable mode \n\
     r16  0 360 arc fill   } bind def \n\
/UN  {  %% unstable node  \n\
     r16  0 360 arc       \n\
     gsave  1 setgray fill grestore \n\
     stroke } bind def \n\
/SL {   %% saddle   \n\
     2 copy UN 2 copy                   \n\
     r16 90 270 arc lineto fill } bind def \n\
/VL { %% vertical line  \n\
     moveto \n\
     0 r64        rlineto \n\
     0 r64 -2 mul rlineto \n\
     stroke } bind def \n\
/HL { %% horizontal line  \n\
     moveto \n\
     r64 0        rlineto \n\
     r64 -2 mul 0 rlineto \n\
     stroke } bind def \n\
/T { %% triangle    \n\
     moveto \n\
     0 r16 rmoveto   \n\
     r16 neg  r32 neg rlineto   \n\
     r32     0       rlineto   \n\
     r16 neg  r32     rlineto   \n\
     gsave  1 setgray fill grestore \n\
     stroke } bind def \n\
/FT { %% filled triangle           \n\
     moveto                        \n\
     0 r16 rmoveto                 \n\
     r16 neg  r32 neg rlineto      \n\
     r32     0        rlineto      \n\
     r16 neg  r32     rlineto      \n\
     fill } bind def               \n\
/IT { %% inverted triangle         \n\
     moveto                        \n\
     0 r16 neg rmoveto             \n\
     r16 neg r32      rlineto      \n\
     r32     0        rlineto      \n\
     r16 neg r32 neg  rlineto      \n\
     gsave  1 setgray fill grestore\n\
     stroke } bind def             \n\
/FIT { %% filled inverted triangle \n\
     moveto                        \n\
     0 r16 neg rmoveto             \n\
     r16 neg r32      rlineto      \n\
     r32     0        rlineto      \n\
     r16 neg r32 neg  rlineto      \n\
     fill } bind def               \n\
/D { %% diamond                    \n\
     moveto                        \n\
     0 r16 rmoveto                 \n\
     r16 neg  r16 neg rlineto      \n\
     r16      r16 neg rlineto      \n\
     r16      r16     rlineto      \n\
     r16 neg  r16     rlineto      \n\
     gsave  1 setgray fill grestore\n\
     stroke } bind def             \n");
(void) printf ("\
/FD { %% filled diamond            \n\
     moveto                        \n\
     0 r16 rmoveto                 \n\
     r16 neg  r16 neg rlineto      \n\
     r16      r16 neg rlineto      \n\
     r16      r16     rlineto      \n\
     r16 neg  r16     rlineto      \n\
     fill } bind def               \n\
/C { %% cross                      \n\
     moveto                        \n\
     r8 neg 0 rmoveto              \n\
     r16    0 rlineto              \n\
     r8 neg r8 neg rmoveto         \n\
     0 r16      rlineto            \n\
     stroke } bind def             \n\
/S { %% square                     \n\
     moveto                        \n\
     r8 neg r8 neg rmoveto         \n\
     r16 0  rlineto                \n\
     0  r16 rlineto                \n\
     r16 neg 0 rlineto             \n\
     closepath                     \n\
     gsave 1 setgray fill grestore \n\
     stroke } bind def             \n\
/FS { %% filled square             \n\
     moveto                        \n\
     r8 neg r8 neg rmoveto         \n\
     r16 0  rlineto                \n\
     0  r16 rlineto                \n\
     r16 neg 0 rlineto             \n\
     closepath                     \n\
     fill } bind def               \n\
/M   {  moveto } bind def          \n\
/LT  {  lineto } bind def          \n\
/RLT { rlineto } bind def          \n\
/SD0 { [             ] 0 setdash } bind def \n\
/SD1 { [ d2 d4       ] 0 setdash } bind def \n\
/SD2 { [ d  d4       ] 0 setdash } bind def \n\
/SD3 { [ d4 d4       ] 0 setdash } bind def \n\
/SD4 { [ d2 d2       ] 0 setdash } bind def \n\
/SD5 { [ d4 d2 d  d2 ] 0 setdash } bind def \n\
/SD6 { [ d8 d4 d  d4 ] 0 setdash } bind def \n\
/DD  {  %% dashed demo  \n\
 gsave 0.1 -0.6 rlineto stroke grestore 0.05 0 rmoveto  \n\
} bind def \n\n\
%% demo 1 \n\n\
%% to see dashed lines uncomment the following 8 lines \n\
%%  (cancel the %% sign)           \n\n\
%%  0.3 0.8 M \n\
%%  SD1 DD \n\
%%  SD2 DD \n\
%%  SD3 DD \n\
%%  SD4 DD \n\
%%  SD5 DD \n\
%%  SD6 DD \n\
%%  SD0 DD \n\n\
%% to use dashed lines \n\n\
%% 0.5 0.6 M \n\n\
%% 0.6 0.6 LT \n\
%% 0.6 0.5 LT \n\
%% 0.7 0.5 LT \n\
%% 0.7 0.4 LT \n\
%% 0.6 0.4 LT \n\
%% 0.6 0.2 LT \n\
%% 0.5 0.2 LT \n\
%% 0.5 0.4 LT \n\
%% 0.4 0.4 LT \n\
%% 0.4 0.5 LT \n\
%% 0.5 0.5 LT \n\
%% 0.5 0.6 LT \n\n\
%% SD6 \n\
%% stroke \n\
%% SD0 \n\n\
%% you can redefine a function (say P) to LT by \n\
%% /P {LT} def \n\n\
/L   { %% line                     \n\
  4 copy pop pop moveto            \n\
  lineto pop pop stroke} bind def\n\n\
/CLIP {                            \n\
 4 copy pop pop moveto             \n\
 3 copy pop exch lineto            \n\
 2 copy          lineto            \n\
 4 copy exch pop exch pop lineto   \n\
 pop pop pop pop                   \n\
 closepath clip newpath } def      \n\n\
");

(void) printf ("\
/LATIN {                       \n\
 /Times-Roman findfont         \n\
 16 s0 div scalefont setfont   \n\
} def                        \n\n\
/GREEK {                       \n\
 /Symbol findfont              \n\
 16 s0 div scalefont setfont   \n\
} def                        \n\n\
/LOWINDEX {                    \n\
 0.005 -0.015 rmoveto} def   \n\n\
%% demo 2                    \n\n\
%% to draw a bounding box uncomment the following 4 lines \n\n\
%%  0 0 1 0  L                     \n\
%%  1 0 1 1  L                     \n\
%%  1 1 0 1  L                     \n\
%%  0 1 0 0  L                   \n\n\
%% demo 3                    \n\n\
%% to see axis label uncomment the following 4 lines \n\n\
%% 0.85 0.04 moveto   LATIN (time) show \n\
%%           LOWINDEX GREEK (a)    show \n\
%% 0.06 0.80 moveto   GREEK (b)    show \n\
%%           LOWINDEX LATIN (2)    show \n\n\
%% demo 4                    \n\n\
%% to see marks uncomment the following 14 lines \n\n\
%% 0.22 0.22 0.87 0.87 L   \n\
%% 0.25 0.25           P   \n\
%% 0.30 0.30           SN  \n\
%% 0.35 0.35           UN  \n\
%% 0.4  0.4            SL  \n\
%% 0.45 0.45           T   \n\
%% 0.5  0.5            FT  \n\
%% 0.55 0.55           IT  \n\
%% 0.6  0.6            FIT \n\
%% 0.65 0.65           D   \n\
%% 0.7  0.7            FD  \n\
%% 0.75 0.75           C   \n\
%% 0.8  0.8            S   \n\
%% 0.85 0.85           FS  \n\n\
%% to change the function P to draw a triangle instead of a point  \n\
%% insert the following line (without the %% sign)  \n\
%% at the place you want the change from  \n\
%% /P { T } def                         \n\n\
LATIN                                   \n\n\
%% Here begins the output               \n\n\
");
} /* printPSprolog */
/*********************************************/
void printPSepilog ()
{
(void) printf ("\
%% quit             \n\n\
showpage              \n\
grestore            \n\n\
");
} /* printPSepilog */
/*********************************************/
void makePSgrid (N)
 int N;
{
 int i;
 real x1,yl,x2,y2;

 for (i=0;i<=N;i++) {
  x1 = 0;
  yl = i/(double)N;
  x2 = 1;
  y2 = yl;
  (void) printf ("%G %G %G %G L\n",x1,yl,x2,y2);
 };

 for (i=0;i<=N;i++) {
  x1 = i/(double)N;
  yl = 0;
  x2 = x1;
  y2 = 1;
  (void) printf ("%G %G %G %G L\n",x1,yl,x2,y2);
 };
} /* makePSgrid */
/*********************************************/
/***********************************************/
/* End of file easynum.c */
